/////////////////////////////////////////////////////////////////////////////
// ChildFrm.cpp : CChildFrame NX̓̒`s܂B
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"

#include "ChildFrm.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_ERASEBKGND()
  #if _MSC_VER >= 1300	//+++ vc7MFCChevronT|[ĝ悤?Ȃ̂ŁALZ.
	ON_NOTIFY_EX_RANGE(RBN_CHEVRONPUSHED, 0, 0xFFFF, OnChevronPushed)
  #endif
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame NX̍\z/

#if 0	//+++ wb_ֈړ
CChildFrame::CChildFrame()
	: m_TabIndex(-1)
{
}
#endif

/// fXgN^
CChildFrame::~CChildFrame()
{
}

///
BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style = WS_VISIBLE | WS_CHILD | WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
		| FWS_PREFIXTITLE | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;

	//if (g_Options.TabMode)
	//	cs.style&=~WS_SYSMENU;
	//cs.style &=~WS_MAXIMIZE;

	CMDIFrameWnd* pMainFrame = (CMDIFrameWnd*)AfxGetMainWnd();
	/*
	if (g_Options.TabMode || (pMainFrame->MDIGetActive() && !pMainFrame->MDIGetActive()->IsZoomed() )) {
		cs.style &=~WS_MAXIMIZE;
	}
	*/
	if (g_Options.TabMode && !pMainFrame->IsIconic()) {
		CRect rect = ((CMainFrame*)pMainFrame)->CalcTabmodeSize();
		cs.x  = rect.left;
		cs.cx = rect.Width();
		cs.y  = rect.top;
		cs.cy = rect.Height();
		/*
		CRect rect;pMainFrame->GetWindow(GW_CHILD)->GetClientRect(rect);
		cs.x = rect.right-6;
		cs.cx = rect.Width();
		cs.y = rect.bottom-6;
		cs.cy = rect.Height();
		*/
	}
	if ( !CMDIChildWnd::PreCreateWindow(cs) ) {
		return FALSE;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame NX̐ff

#ifdef _DEBUG
///
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

///
void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif // _DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame NX̃bZ[Wnh

/// I
BOOL CChildFrame::DestroyWindow()
{
	try{
		// ((CHtmlView*)GetActiveView())->Stop();

		// ̃^uANeBu
		CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
		if ( m_TabIndex == pMainFrame->m_wndTabBar.GetCurSel() && m_TabIndex >= 0 ) {
			switch(g_Options.TabPosDel){
			case 1://ANeBủE
				if ( m_TabIndex < pMainFrame->m_Tabs.count()-1 ) {
					pMainFrame->SetTab(m_TabIndex+1);
				} else if (pMainFrame->m_Tabs.count()>1) {
					pMainFrame->SetTab(pMainFrame->m_Tabs.count()-2);
				}
				break;
			case 2://ANeBu̍
				if ( m_TabIndex > 0 ) {
					pMainFrame->SetTab(m_TabIndex-1);
				} else if (pMainFrame->m_Tabs.count()>1) {
					pMainFrame->SetTab(0);
				}
				break;
			}
		}
	} catch(...) {
		AfxMessageBox( _T("Err:Destroy") );
	}
	return CMDIChildWnd::DestroyWindow();
}

/// 쐬
BOOL CChildFrame::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CMDIFrameWnd* pParentWnd, CCreateContext* pContext)
{
	if (pParentWnd == NULL) {
		CWnd* pMainWnd = AfxGetThread()->m_pMainWnd;
		ASSERT(pMainWnd != NULL);
		ASSERT_KINDOF(CMDIFrameWnd, pMainWnd);
		pParentWnd = (CMDIFrameWnd*)pMainWnd;
	}
	ASSERT(::IsWindow(pParentWnd->m_hWndMDIClient));

	// insure correct window positioning
	pParentWnd->RecalcLayout();

	// first copy into a CREATESTRUCT for PreCreate
	CREATESTRUCT cs = {0};
	cs.dwExStyle  = 0L;
	cs.lpszClass  = lpszClassName;
	cs.lpszName   = lpszWindowName;
	cs.style	  = dwStyle;
	cs.x		  = rect.left;
	cs.y		  = rect.top;
	cs.cx		  = rect.right - rect.left;
	cs.cy		  = rect.bottom - rect.top;
	cs.hwndParent = pParentWnd->m_hWnd;
	cs.hMenu	  = NULL;
	cs.hInstance  = AfxGetInstanceHandle();
	cs.lpCreateParams = (LPVOID)pContext;

	if (!PreCreateWindow(cs)) {
		PostNcDestroy();
		return FALSE;
	}
	// extended style must be zero for MDI Children (except under Win4)
	//ASSERT(afxData.bWin4 || cs.dwExStyle == 0);
	ASSERT(cs.hwndParent == pParentWnd->m_hWnd);	// must not change

	// now copy into a MDICREATESTRUCT for real create
	MDICREATESTRUCT mcs = {0};
	mcs.szClass = cs.lpszClass;
	mcs.szTitle = cs.lpszName;
	mcs.hOwner	= cs.hInstance;
	mcs.x		= cs.x;
	mcs.y		= cs.y;
	mcs.cx		= cs.cx;
	mcs.cy		= cs.cy;
	mcs.style	= cs.style & ~(WS_MAXIMIZE | WS_VISIBLE);

	mcs.lParam	= (LPARAM)cs.lpCreateParams;		//+++@ LONGLPARAM

	// create the window through the MDICLIENT window
	AfxHookWindowCreate(this);
	HWND   hWnd = (HWND)::SendMessage(pParentWnd->m_hWndMDIClient,
		WM_MDICREATE, 0, (LPARAM)&mcs);
	if (!AfxUnhookWindowCreate()) {
		PostNcDestroy();		// cleanup if MDICREATE fails too soon
	}

	if (hWnd == NULL) {
		return FALSE;
	}

	// special handling of visibility (always created invisible)
	if (cs.style & WS_VISIBLE) {
		// ͂ƂŐVKqEBhEĂɃANeBuɂȂ̂h܂
		/*
		// place the window on top in z-order before showing it
		::BringWindowToTop(hWnd);
		// show it as specified

		if (cs.style & WS_MINIMIZE)
			ShowWindow(SW_SHOWMINIMIZED);
		else if (cs.style & WS_MAXIMIZE)
			ShowWindow(SW_SHOWMAXIMIZED);
		else
			ShowWindow(SW_SHOWNA);

		// make sure it is active (visibility == activation)
		pParentWnd->MDIActivate(this);
		*/
	}
	ASSERT(hWnd == m_hWnd);
	return TRUE;
}

///
BOOL CChildFrame::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}


// ========================================================================
// +++ Ώ... ł̂͂悭킩.

#if _MSC_VER >= 1300	//+++ vc7 MFCChevronT|[gꂽ߁AӐ}IɃLZđΏ...
///
afx_msg BOOL CChildFrame::OnChevronPushed(UINT id, NMHDR * pNotifyStruct, LRESULT* result )
{
	return FALSE;
}
#endif
