/////////////////////////////////////////////////////////////////////////////
// DlgFilter.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalOption.h"
#include "resource.h"
#include "patriotGlobal2.h"
#include "DlgFilter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CGlobalOption g_Options;

/////////////////////////////////////////////////////////////////////////////
// CDlgFilter _CAO

/// RXgN^
CDlgFilter::CDlgFilter(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFilter::IDD, pParent)
	, m_Filter()
{
	//{{AFX_DATA_INIT(CDlgFilter)
	m_Url		  = _T("");
	m_Image 	  = 2;
	m_Bgm		  = 2;
	m_Video 	  = 2;
	m_Script	  = 2;
	m_Java		  = 2;
	m_ActiveX	  = 2;
	m_ActiveX2	  = 2;
	m_AntiPopup   = 2;
	m_ShiftLock   = 2;
	m_TabLock	  = 2;
	m_Silent	  = 2;
	m_Cookie	  = 2;
	m_Cookie2	  = 2;
	m_Proxy 	  = _T("");
	m_UseSecurity = FALSE;
	//}}AFX_DATA_INIT
}

///
void CDlgFilter::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFilter)
	DDX_Text(pDX , IDC_EDIT1  , m_Url);
	DDX_Check(pDX, IDC_CHECK1 , m_Image);
	DDX_Check(pDX, IDC_CHECK2 , m_Bgm);
	DDX_Check(pDX, IDC_CHECK3 , m_Video);
	DDX_Check(pDX, IDC_CHECK4 , m_Script);
	DDX_Check(pDX, IDC_CHECK5 , m_Java);
	DDX_Check(pDX, IDC_CHECK6 , m_ActiveX);
	DDX_Check(pDX, IDC_CHECK7 , m_ActiveX2);
	DDX_Check(pDX, IDC_CHECK8 , m_AntiPopup);
	DDX_Check(pDX, IDC_CHECK9 , m_ShiftLock);
	DDX_Check(pDX, IDC_CHECK10, m_TabLock);
	DDX_Check(pDX, IDC_CHECK11, m_Silent);
	DDX_Check(pDX, IDC_CHECK12, m_Cookie);
	DDX_Check(pDX, IDC_CHECK13, m_Cookie2);
	DDX_CBString(pDX,IDC_COMBO2,m_Proxy);
	DDX_Check(pDX, IDC_CHECK14, m_UseSecurity);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgFilter, CDialog)
	//{{AFX_MSG_MAP(CDlgFilter)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_CHECK14  , OnCheck14)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDlgFilter bZ[W nh

///
BOOL CDlgFilter::OnInitDialog()
{
	CDialog::OnInitDialog();

	CComboBox* pCombo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);
	CComboBox* pCombo2 = (CComboBox*)GetDlgItem(IDC_COMBO2);

	int nIndex = 0;

	// PROXY
	if ( m_Proxy ==  _T("NOT") || m_Proxy == _T("")  ) {
		// ̓
		m_Proxy =  _T("");
		nIndex	= 0;
	} else if ( m_Proxy ==	_T("app:close") || m_Proxy ==  _T("app:neglect") ) {
		// Ȃ
		m_Proxy =  _T("");
		nIndex	= 1;
	} else if ( m_Proxy.GetLength() > 8 && m_Proxy.Left(8) == _T("sendurl:")  ) {
		// URL𑗂
		m_Proxy = m_Proxy.Mid( 9, m_Proxy.GetLength() - 10 );
		nIndex	= 2;
	} else if ( m_Proxy.GetLength() > 10 && m_Proxy.Left(10) == _T("extension:")  ) {
		// gN
		m_Proxy = m_Proxy.Mid( 11, m_Proxy.GetLength()-12 );
		nIndex	= 3;
	} else {
		m_Proxy.Replace( _T("proxy:"), _T("") );
		nIndex	= 4;
	}

	pCombo1->SetCurSel(nIndex);
	OnSelchangeCombo1();

	int i = 0;
	for ( CString str; i < pCombo2->GetCount(); i++ ) {
		pCombo2->GetLBText( i, str );
		if ( str == m_Proxy ) {
			break;
		}
	}
	pCombo2->SetCurSel(i);

	// ^u̐ݒύX
	for ( i = 0; i < 13; i++ ) {
		m_UseSecurity = ( (CButton*)GetDlgItem( IDC_CHECK1 + i ) )->GetCheck() == 2 ? m_UseSecurity : TRUE ;
	}

	( (CButton*)GetDlgItem( IDC_CHECK14 ) )->SetCheck( m_UseSecurity ? 1 : 0 );

	for ( i = 0; i < 13; i++ ) {
		( (CButton*)GetDlgItem( IDC_CHECK1 + i ) )->EnableWindow( m_UseSecurity );
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// OK{^ꂽ
void CDlgFilter::OnOK()
{
	UpdateData();
	CComboBox* pCombo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);

	switch( pCombo1->GetCurSel() ){
	case 0://̓
		m_Filter.strProxy = _T("");
		break;
	case 1://
		m_Filter.strProxy = _T("app:close");
		break;
	case 2://URL𑗂
		m_Filter.strProxy = _T("sendurl:[") + m_Proxy + _T("]");
		break;
	case 3://g@\N
		m_Filter.strProxy = _T("extension:[") + m_Proxy + _T("]");
		break;
	case 4://vNVύX
		if (m_Proxy== _T("C^[lbgIvV") )
			m_Filter.strProxy = _T("proxy:InternetOption");
		else if (m_Proxy== _T("") )
			m_Filter.strProxy = _T("proxy:direct");
		else
			m_Filter.strProxy = _T("proxy:")  + m_Proxy;
		break;
	}

	m_Filter.strUrl = m_Url;

	if ( m_UseSecurity ) {
		m_Filter.bImage 	= m_Image;
		m_Filter.bBgm		= m_Bgm;
		m_Filter.bVideo 	= m_Video;
		m_Filter.bScript	= m_Script;
		m_Filter.bJava		= m_Java;
		m_Filter.bActiveX	= m_ActiveX;
		m_Filter.bActiveX2	= m_ActiveX2;
		m_Filter.bSilent	= m_Silent;
		m_Filter.bAntiPopup = m_AntiPopup;
		m_Filter.bShiftLock = m_ShiftLock;
		m_Filter.bTabLock	= m_TabLock;
		m_Filter.bCookie	= m_Cookie;
		m_Filter.bCookie2	= m_Cookie2;
	}
	else{
		m_Filter.bImage 	= 2;
		m_Filter.bBgm		= 2;
		m_Filter.bVideo 	= 2;
		m_Filter.bScript	= 2;
		m_Filter.bJava		= 2;
		m_Filter.bActiveX	= 2;
		m_Filter.bActiveX2	= 2;
		m_Filter.bSilent	= 2;
		m_Filter.bAntiPopup = 2;
		m_Filter.bShiftLock = 2;
		m_Filter.bTabLock	= 2;
		m_Filter.bCookie	= 2;
		m_Filter.bCookie2	= 2;
	}
	CDialog::OnOK();
}

/// ANVύX
void CDlgFilter::OnSelchangeCombo1()
{
	CComboBox* pCombo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);
	CComboBox* pCombo2 = (CComboBox*)GetDlgItem(IDC_COMBO2);
	pCombo2->ResetContent();

	switch (pCombo1->GetCurSel()) {
	case 0://̓
		break;
	case 1://
		break;
	case 2://URL𑗂
		::LoadIniSectionNamesToCombobox( g_Options.strOptionPath + _T("\\sendurl.ini"), pCombo2 );
		break;
	case 3://g@\N
		::LoadIniSectionNamesToCombobox( g_Options.strAppPath + _T("\\extension\\default.ini"), pCombo2 );
		::LoadIniSectionNamesToCombobox( g_Options.strAppPath + _T("\\extension\\user.ini"), pCombo2 );
		break;
	case 4://vNVύX
		TRY{
			//+++ CStdioFile fin( g_Options.strOptionPath + _T("\\proxy.dat"), CFile::modeRead);
			CReadTextFile fin( g_Options.strOptionPath + _T("\\proxy.dat"), CFile::modeRead);

			pCombo2->AddString( _T("C^[lbgIvV") );
			pCombo2->AddString( _T("") );
			CString str;
			while (fin.ReadString(str)) {
				pCombo2->AddString(str);
			}
			fin.Close();
		}
		CATCH( CFileException, e ){
			if ( e->m_cause != CFileException::fileNotFound) {
				TRACE( _T("File could not be opened %d \n")  , e->m_cause);
			}
		}END_CATCH

		if (m_Proxy== _T("InternetOption") ) {
			m_Proxy= _T("C^[lbgIvV");
		} else if (m_Proxy== _T("direct") ) {
			m_Proxy= _T("");
		}
		break;
	}

	pCombo2->SetCurSel(0);
}

///
void CDlgFilter::OnCheck14()
{
	UpdateData();
	for ( int i = 0; i < 13; i++ ) {
		( (CButton*)GetDlgItem( IDC_CHECK1 + i ) )->EnableWindow( m_UseSecurity );
	}
}
