/////////////////////////////////////////////////////////////////////////////
// InternetProtocol.cpp : Implementation of CGreenBrowserApp and DLL registration.
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "InternetProtocol.h"
#include "patriot.h"
#include "patriotGlobal2.h"

static const //+++ ǉ.
BYTE bytePlaceHold[] = {0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x01, 0x00,
						0x01, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
						0xFF, 0xFF, 0xFF, 0x21, 0xF9, 0x04, 0x01, 0x00,
						0x00, 0x00, 0x00, 0x2C, 0x00, 0x00, 0x00, 0x00,
						0x01, 0x00, 0x01, 0x00, 0x00, 0x02, 0x01, 0x44,
						0x00, 0x3B
};


/////////////////////////////////////////////////////////////////////////////
/// CInternetProtocol
/////////////////////////////////////////////////////////////////////////////


///----------------------------------------------------------------------------
/// IInternetProtocolRoot 
///----------------------------------------------------------------------------
STDMETHODIMP CInternetProtocol::Start(
	LPCWSTR 				szUrl,
	IInternetProtocolSink	*pIProtSink,
	IInternetBindInfo		*pIBindInfo,
	DWORD					grfSTI,
	HANDLE_PTR				dwReserved)
{
	try {
	  #ifdef UNICODE	//+++ unicodeΉ.
		int size = int( g_Options.arrContentFilter.GetSize() );
		for (int i = 0; i < size; i++) {
			if (StrMatch(g_Options.arrContentFilter.GetAt(i), szUrl)) {
				if (pIProtSink != NULL) {
					pIProtSink->AddRef();
					pIProtSink->ReportData(BSCF_FIRSTDATANOTIFICATION || BSCF_LASTDATANOTIFICATION || BSCF_DATAFULLYAVAILABLE, 42, 42);
					pIProtSink->ReportResult(S_OK, 0, 0);
					pIProtSink->Release();

					int nCount = g_Options.arrContentFilterCounts.GetAt(i);
					g_Options.arrContentFilterCounts.SetAt(i, nCount + 1);
				}
				return S_OK;
			}
		}
	  #else
		const int MAX_INET_PATH = 2083;
		char	  strURL[MAX_INET_PATH+1];
		::WideCharToMultiByte( CP_ACP, 0, szUrl, -1, strURL, MAX_INET_PATH, NULL, NULL );

		int size = int( g_Options.arrContentFilter.GetSize() );

		for (int i = 0; i < size; i++) {
			if (StrMatch(g_Options.arrContentFilter.GetAt(i), strURL)) {
				if (pIProtSink != NULL) {
					pIProtSink->AddRef();
					pIProtSink->ReportData(BSCF_FIRSTDATANOTIFICATION || BSCF_LASTDATANOTIFICATION || BSCF_DATAFULLYAVAILABLE, 42, 42);
					pIProtSink->ReportResult(S_OK, 0, 0);
					pIProtSink->Release();

					int nCount = g_Options.arrContentFilterCounts.GetAt(i);
					g_Options.arrContentFilterCounts.SetAt(i, nCount + 1);
				}
				return S_OK;
			}
		}
	  #endif
	} catch(...) {
	}
	return INET_E_USE_DEFAULT_PROTOCOLHANDLER;
}

///----------------------------------------------------------------------------
/// IInternetProtocol 
///----------------------------------------------------------------------------
STDMETHODIMP CInternetProtocol::Read(void *pv,ULONG cb,ULONG *pcbRead)
{
	try{
		if (cb >= 42 && pv != NULL) {
			memcpy(pv, bytePlaceHold, 42);
			*pcbRead =	42;
		} else {
			*pcbRead = 0;
		}
	} catch (...) {}
	return S_FALSE;
}

/*
		const int MAX_INET_PATH = 2083;
		char strURL[MAX_INET_PATH];
		::WideCharToMultiByte( CP_ACP, 0, szUrl, -1, strURL, MAX_INET_PATH, NULL, NULL );

		int size = g_Options.arrContentFilter.GetSize();

		for (int i = 0; i < size; i++) {
			if (StrMatch(g_Options.arrContentFilter.GetAt(i), strURL)) {
				if (pIProtSink != NULL) {
					pIProtSink->AddRef();
					pIProtSink->ReportData(BSCF_FIRSTDATANOTIFICATION || BSCF_LASTDATANOTIFICATION || BSCF_DATAFULLYAVAILABLE, 42, 42);
					pIProtSink->ReportResult(S_OK, 0, 0);
					pIProtSink->Release();

					int nCount = g_Options.arrContentFilterCounts.GetAt(i);
					g_Options.arrContentFilterCounts.SetAt(i, nCount + 1);
				}
				return S_OK;
			}
		}
	} catch(...) {
	}

	return INET_E_USE_DEFAULT_PROTOCOLHANDLER;
}


STDMETHODIMP CPatriotInternetProtocol::Continue(PROTOCOLDATA *pStateInfo)
{
	return S_OK;
}

STDMETHODIMP CPatriotInternetProtocol::Abort(HRESULT hrReason,DWORD dwOptions)
{
	return E_NOTIMPL;
}

STDMETHODIMP CPatriotInternetProtocol::Terminate(DWORD dwOptions)
{
	return	S_OK;
}

STDMETHODIMP CPatriotInternetProtocol::Suspend()
{
ATLTRACENOTIMPL("Suspend\n");

	return E_NOTIMPL;
}

STDMETHODIMP CPatriotInternetProtocol::Resume()
{
ATLTRACENOTIMPL("Resume\n");

	return E_NOTIMPL;
}

// IInternetProtocol::Read
// -----------------------

// This is how URLMON asks us for data. As we report data on the protocol sink,
// URLMON will periodically ask us for data via this method.

// How URLMON asks for data will not always correlate directly to what data is
// reported.

// Do not expect to see 1 and only 1 Read method for each time data is reported
// to the protocol sink (give URLMON what it asks for if you can.)

// Expect that extra read calls may come in after all the data in the buffer has
// been read (continue to return S_FALSE.)

// The amount requested may sometimes be much more than what was reported. URLMON
// typically looks for data in 4k buffers, but do not depend on this.

STDMETHODIMP CPatriotInternetProtocol::Read(void *pv, ULONG cb, ULONG *pcbRead)
{
	try{

	if(cb>=42 && pv!=NULL)
	{
		memcpy(pv, bytePlaceHold, 42);
		*pcbRead =	42;
	}
	else
		*pcbRead = 0;

	}catch(...){}

	return S_FALSE;
}

STDMETHODIMP CPatriotInternetProtocol::Seek(
		LARGE_INTEGER dlibMove,
		DWORD dwOrigin,
		ULARGE_INTEGER *plibNewPosition)
{
ATLTRACENOTIMPL("Seek\n");

	return E_NOTIMPL;
}

STDMETHODIMP CPatriotInternetProtocol::LockRequest(DWORD dwOptions)
{
ATLTRACE(_T("LockRequest\n"));


	return S_OK;
}

STDMETHODIMP CPatriotInternetProtocol::UnlockRequest()
{
ATLTRACE(_T("UnlockRequest\n"));

	return S_OK;
}

STDMETHODIMP CPatriotInternetProtocol::CombineUrl(LPCWSTR pwzBaseUrl, LPCWSTR pwzRelativeUrl, DWORD dwCombineFlags,
	LPWSTR pwzResult, DWORD cchResult, DWORD *pcchResult, DWORD dwReserved)
{
ATLTRACE(_T("CombineURL\n"));

	return INET_E_DEFAULT_ACTION;
}

STDMETHODIMP CPatriotInternetProtocol::CompareUrl(LPCWSTR pwzUrl1, LPCWSTR pwzUrl2, DWORD dwCompareFlags)
{
ATLTRACE(_T("CompareUrl\n"));
	// Ignoring dwCompareFlags
	if (0 == wcscmp(pwzUrl1, pwzUrl2))
		return S_OK;
	else
		return S_FALSE;
}

// IInternetProtocolInfo::ParseUrl
// -------------------------------
//
// Unlike the other methods of IIPI, ParseUrl is worthy of note:
//
// 1. ParseUrl is used in many HTML-based security checks. If you seem to be having a security
//	  problem with your own protocol, it is probably due to your ParseUrl implementation.
//
// 2. ParseUrl is called many many times, even when the protocol is not doing a bind. Be aware
//	  that this is used as a "general utility" function by IE for parsing and checking on URLs.
//	  For example, mousing over a hyperlink to a X-DB2XML URL will cause MSHTML to call
//	  CoInternetParseUrl 2 or more times. Every call will cocreate a new instance of this protocol
//	  handler object, call IIPI::ParseUrl, and destroy the protocol handler instance.

// Our protocol handler "cheats". We pretend that the URL we were passed as the UDL file path is
// actually our URL. This allows us to easily map ourselves to the HTTP(S) protocol so that HTML
// pages served by HTTP(S) don't continually run into security problems with our protocol. Normally
// it is Against The Rules for web pages to access data across domains or between different protocols.

STDMETHODIMP CPatriotInternetProtocol::ParseUrl(LPCWSTR pwzUrl, PARSEACTION ParseAction, DWORD dwParseFlags,
	LPWSTR pwzResult, DWORD cchResult, DWORD *pcchResult, DWORD dwReserved)
{
ATLTRACE(_T("ParseUrl\n"));

//	HRESULT hr = CoInternetParseUrl(m_url, ParseAction, dwParseFlags, pwzResult, dwUrlLen, pcchResult, dwReserved);

	return INET_E_DEFAULT_ACTION;
}

// TODO: Implement queryinfo against xml result set... not UDL file
STDMETHODIMP CPatriotInternetProtocol::QueryInfo( LPCWSTR pwzUrl, QUERYOPTION QueryOption, DWORD dwQueryFlags,
	LPVOID pBuffer, DWORD cbBuffer, DWORD *pcbBuf, DWORD dwReserved)
{
ATLTRACE(_T("QueryInfo\n"));

	return INET_E_DEFAULT_ACTION;
}
*/
