/////////////////////////////////////////////////////////////////////////////
// SidebarFavorites.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "SidebarFavorites.h"
#include "patriotGlobal.h"
#include "DlgFilter.h"
#include "InputBox.h"
#include "MainFrm.h"
#include "FavoritesOrder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSidebarFavorites

#if 0	//+++ wb_ֈړ
CSidebarFavorites::CSidebarFavorites()
{
}
#endif

/// fXgN^
CSidebarFavorites::~CSidebarFavorites()
{
}


BEGIN_MESSAGE_MAP(CSidebarFavorites, CFileTreeCtrl)
	//{{AFX_MSG_MAP(CSidebarFavorites)
	ON_WM_CREATE()
	ON_COMMAND(ID_SIDEBAR_OPENSEARCHBAR, OnSidebarOpensearchbar)
	ON_COMMAND(ID_SIDEBAR_OPENFOLDER, OnSidebarOpenFolder)
	ON_COMMAND(ID_SIDEBAR_PROPERTY2, OnSidebarProperty)
	ON_COMMAND(ID_SIDEBAR_PROPERTY, OnSidebarFilter)
	ON_COMMAND(ID_SIDEBAR_ADDHERE, OnSidebarAddhere)
	ON_COMMAND(ID_SIDEBAR_CLEARORDER, OnSidebarClearorder)
	ON_WM_MBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSidebarFavorites o֐

/// J
BOOL CSidebarFavorites::OpenFile(BOOL bNewWindow)
{
	if (ItemIsFolder(m_ClickedItem)) {
		return FALSE;
	}
	CString strFileName = GetSelectedFileName();
	if (strFileName!= _T("") && (strFileName.Right(m_strSuffix.GetLength()).CompareNoCase(m_strSuffix) == 0 || strFileName.Right(4).CompareNoCase(_T(".lnk") ) == 0 )) {
		OpenShortcut(strFileName, bNewWindow, g_Options.bATFavorites);
	}
	if (g_Options.bATFavorites) {
		((CMDIFrameWnd*)AfxGetMainWnd())->MDIGetActive()->GetActiveView()->SetFocus();
	}
	return TRUE;
}

/// j[擾
CMenu* CSidebarFavorites::GetContextMenu()
{
	CMenu* pMenu = new CMenu;
	if (ItemIsFolder(m_ClickedItem)) { // tH_
		pMenu->LoadMenu(IDR_SIDEBARFAVORITES);
		pMenu->GetSubMenu(0)->DeleteMenu(0, MF_BYPOSITION);
		pMenu->GetSubMenu(0)->DeleteMenu(0, MF_BYPOSITION);
		pMenu->GetSubMenu(0)->DeleteMenu(0, MF_BYPOSITION);
		pMenu->GetSubMenu(0)->DeleteMenu(0, MF_BYPOSITION);
	}
	else{ // t@C
		pMenu->LoadMenu(IDR_SIDEBARFAVORITES);
		pMenu->GetSubMenu(0)->DeleteMenu(3, MF_BYPOSITION);
		pMenu->GetSubMenu(0)->DeleteMenu(3, MF_BYPOSITION);
		pMenu->GetSubMenu(0)->DeleteMenu(3, MF_BYPOSITION);
	}
	if (!g_Options.FavoritesIERegist || !g_Options.FavoritesOperateOrder) {
		// Oŕёւ
		pMenu->GetSubMenu(0)->DeleteMenu(ID_SIDEBAR_CLEARORDER, MF_BYCOMMAND);
	}
	return pMenu;
}

/// ݒύX
void CSidebarFavorites::SetOption()
{
	CFileTreeCtrl::SetOption(g_Options.strFavorites, _T(".url"), 0, 1);
}


/////////////////////////////////////////////////////////////////////////////
// CSidebarFavorites bZ[W nh

/// \z
int CSidebarFavorites::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFileTreeCtrl::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	SetOption();
	return 0;
}

/// hbv^[Qbgo^
void CSidebarFavorites::RegistDropTarget()
{
	if (m_pDropTarget) {		//+++ svAÔ߃K[h.
		assert(m_pDropTarget == 0);
		delete m_pDropTarget;
	}
	m_pDropTarget = new CFavoritesTreeDropTarget;
	m_pDropTarget->RegisterWnd(this);
}

/// ACëʒu擾
int CSidebarFavorites::GetItemIndex(HTREEITEM item)
{
	int index = -1;
	while (item) {
		item = GetPrevSiblingItem(item);
		index++;
	}
	return index;
}

/// o[Ō
void CSidebarFavorites::OnSidebarOpensearchbar()
{
	HTREEITEM item = GetSelectedItem();
	::OpenSendstrCmd( _T("0x {str}"), GetItemText(item), g_Options.bNWSendstr);
}

/// ̃tH_J
void CSidebarFavorites::OnSidebarOpenFolder()
{
	if (!ItemIsFolder(m_ClickedItem)) {
		return;
	}

	CString 	 strFolder = GetSelectedFileName();
	CStringArray arrStr;
	LoadArrFolder(arrStr, strFolder, _T(".url") );

	for (int i = 0; i < arrStr.GetSize(); i++) {
		if (arrStr.GetAt(i).GetLength() > 4 && arrStr.GetAt(i).Right(4).CompareNoCase( _T(".url") ) == 0) {
			OpenShortcut(strFolder + _T("\\") + arrStr.GetAt(i), g_Options.bNWFavorites, g_Options.bATFavorites);
		}
	}
}

/// tB^
void CSidebarFavorites::OnSidebarFilter()
{
	CDlgFilter dlg;
	CString    strPath = GetSelectedFileName();
	strPath = strPath.Mid( g_Options.strFavorites.GetLength() + 1 );
	//strPath = strPath.Right( strPath.GetLength() - g_Options.strFavorites.GetLength() - 1 );
	if (ItemIsFolder(m_ClickedItem)) {
		strPath+= _T("\\*");
	}

	int 		i	   = 0;
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	// łɓo^ĂȂ`FbN
	for (i = 0;i<pFrame->m_FavFilters.count;i++) {
		if (strPath == pFrame->m_FavFilters.pWebFilter[i].strUrl) {
			dlg.m_Image 	= pFrame->m_FavFilters.pWebFilter[i].bImage;
			dlg.m_Bgm		= pFrame->m_FavFilters.pWebFilter[i].bBgm;
			dlg.m_Video 	= pFrame->m_FavFilters.pWebFilter[i].bVideo;
			dlg.m_Script	= pFrame->m_FavFilters.pWebFilter[i].bScript;
			dlg.m_Java		= pFrame->m_FavFilters.pWebFilter[i].bJava;
			dlg.m_ActiveX	= pFrame->m_FavFilters.pWebFilter[i].bActiveX;
			dlg.m_ActiveX2	= pFrame->m_FavFilters.pWebFilter[i].bActiveX2;
			dlg.m_Silent	= pFrame->m_FavFilters.pWebFilter[i].bSilent;
			dlg.m_ShiftLock = pFrame->m_FavFilters.pWebFilter[i].bShiftLock;
			dlg.m_TabLock	= pFrame->m_FavFilters.pWebFilter[i].bTabLock;
			dlg.m_AntiPopup = pFrame->m_FavFilters.pWebFilter[i].bAntiPopup;
			dlg.m_Cookie	= pFrame->m_FavFilters.pWebFilter[i].bCookie;
			dlg.m_Cookie2	= pFrame->m_FavFilters.pWebFilter[i].bCookie2;
			dlg.m_Proxy 	= pFrame->m_FavFilters.pWebFilter[i].strProxy;
		}
	}

	dlg.m_Url = strPath;
	if (dlg.DoModal() == IDOK) { // ۑ
		BOOL bUpdate = FALSE;
		// łɓo^Ȃ`FbN
		for (i = 0; i < pFrame->m_FavFilters.count; i++) {
			if (dlg.m_Url == pFrame->m_FavFilters.pWebFilter[i].strUrl) { // ΍XV
				if (pFrame->m_FavFilters.GetStringFromFilter(dlg.m_Filter) == _T("2222222222222") && dlg.m_Filter.strProxy == _T("NOT")) {// ׂĂ̐ݒ肪uv
					pFrame->m_FavFilters.Delete(i);
				} else {//XV
					pFrame->m_FavFilters.pWebFilter[i] = dlg.m_Filter;
					bUpdate = TRUE;
				}
				break;
			}
		}
		if (!bUpdate) { // Ȃ΍Ōɒǉ
			if (pFrame->m_FavFilters.GetStringFromFilter(dlg.m_Filter) != _T("2222222222222") || dlg.m_Filter.strProxy!=_T("NOT") ) {
				pFrame->m_FavFilters.Add(dlg.m_Filter, pFrame->m_FavFilters.count);
			}
		}
		pFrame->m_FavFilters.SaveData( g_Options.strOptionPath + _T("\\favfilter.dat") );
	}
}

/// ̃tH_ɒǉ
void CSidebarFavorites::OnSidebarAddhere()
{
	CMDIFrameWnd* pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
	if (pFrame->MDIGetActive() == NULL) {
		return;
	}
	HTREEITEM itemFolder = GetSelectedItem();
	if (!ItemIsFolder(itemFolder)) {
		itemFolder		 = GetParentItem(itemFolder);
	}
	CString    strFolder = GetItemFileName(itemFolder);
	CHtmlView* pView	 = (CHtmlView*)pFrame->MDIGetActive()->GetActiveView();

	CString    strURL	 = pView->GetLocationURL();
	CString    strTitle  = GetValidFilename(pView->GetLocationName());

	CInputBox  dlg;
	strTitle = dlg.GetInput( _T("Cɓɒǉ"), strFolder + _T(" ɂCɓǉ܂B\n\rCɓ̖O͂ĂB"), strTitle);
	if (strTitle== _T("") ) {
		return;
	}

	if (::WriteShortcut( strFolder + _T("\\") + strTitle + _T(".url"), strURL) == 0) {
		AddFolder(strFolder, GetSelectedItem());
	}
}

/// XV
void CSidebarFavorites::OnSidebarRefreshall()
{
	SetOption();
	CFileTreeCtrl::OnSidebarRefreshall();
}

/// Oɕёւ
void CSidebarFavorites::OnSidebarClearorder()
{
	HTREEITEM item = GetSelectedItem();
	if (item == NULL) {
		return;
	}

	//HTREEITEM itemRoot   = GetRootItem();
	HTREEITEM	itemFolder = GetParentItem(item);
	CString 	strFolder;
	while (NULL != itemFolder) {
		strFolder += _T("\\") + GetItemText(itemFolder);
		itemFolder = GetParentItem(itemFolder);
	}

	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites") + strFolder;

	LONG	lResult = 0;
	HKEY	hKey	= 0;
	lResult = ::RegOpenKeyEx(HKEY_CURRENT_USER, strKeyName, 0, KEY_SET_VALUE, &hKey);
	if (lResult == ERROR_SUCCESS) {
		lResult = ::RegDeleteValue(hKey, _T("Order"));
		::RegCloseKey(hKey);
	}

	AddFolder(g_Options.strFavorites + strFolder, GetParentItem(item));
	/*
		if (lResult != ERROR_SUCCESS) {
			// G[bZ[W\
			LPTSTR lpBuffer;
			::FormatMessage(
				FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				NULL,
				::GetLastError(),
				LANG_USER_DEFAULT,
				(LPTSTR)&lpBuffer,
				0,
				NULL );
			AfxMessageBox(lpBuffer, MB_OK | MB_ICONINFORMATION);
			LocalFree(lpBuffer);
		}
	*/
}

/// NbN
void CSidebarFavorites::OnMButtonDown(UINT nFlags, CPoint point)
{
	if (point.x == -1) { // AvP[VL[őI
		m_ClickedItem = GetSelectedItem();
	}
	else{ // }EXőI
		m_ClickedItem = HitTest(point);
		// tH_
		BOOL bExpand = GetItemState(m_ClickedItem, TVIS_EXPANDED) & TVIS_EXPANDED;
		if (bExpand == FALSE) {
			ModifyStyle(TVS_SINGLEEXPAND, NULL);
			SelectItem(m_ClickedItem);
			ModifyStyle(NULL, TVS_SINGLEEXPAND);
		} else {
			SelectItem(m_ClickedItem);
		}
	}
	if (m_ClickedItem == NULL) {
		return;
	}

	OnSidebarOpenFolder();
}

/// ҏW̏I
void CSidebarFavorites::OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult)
{
	CFileTreeCtrl::OnEndlabeledit(pNMHDR, pResult);
	if (*pResult == 0 && g_Options.FavoritesOperateOrder) {
		HTREEITEM itemSelected	= GetSelectedItem();
		int 	  nItemIndex	= GetItemIndex(itemSelected);
		CString   strItemFolder = GetItemFileName(GetParentItem(itemSelected));

		CFavoritesOrder order;
		order.LoadOrder(strItemFolder);
		order.Rename(nItemIndex, strItemFolder);
		order.SaveOrder();
	}
}

/// ACehbvꂽ
BOOL CSidebarFavorites::OnDropItem(HTREEITEM ItemDrop, HTREEITEM ItemDrag)
{
	if (ItemDrop == ItemDrag) {
		return FALSE;
	}
	if (!g_Options.FavoritesOperateOrder) {
		return CFileTreeCtrl::OnDropItem(ItemDrop, ItemDrag);
	}

	// ёւIEɔf
	BOOL	  bResult			= FALSE;
	BOOL	  bInsertItem		= (GetDropHilightItem() == NULL);
	HTREEITEM ItemDropParent	= GetParentItem(ItemDrop);
	HTREEITEM ItemDragParent	= GetParentItem(ItemDrag);

	int 	  nItemDropIndex	= GetItemIndex(ItemDrop);
	int 	  nItemDragIndex	= GetItemIndex(ItemDrag);

	HTREEITEM ItemDropFolder	= (!bInsertItem && ItemIsFolder(ItemDrop)) ? ItemDrop : ItemDropParent;
	CString   strItemDropFolder = GetItemFileName(ItemDropFolder);

	if (ItemDropParent == ItemDragParent && bInsertItem) {
		// tH_Ԃ̈ړ
		CFavoritesOrder order;
		order.LoadOrder(strItemDropFolder);
		order.Move(nItemDragIndex, nItemDropIndex);
		bResult = order.SaveOrder();
	} else {
		// قȂtH_Ԃ̈ړ
		CString strNewPath = strItemDropFolder + _T("\\") + GetItemText(ItemDrag);
		if (!ItemIsFolder(ItemDrag)) {
			strNewPath += m_strSuffix;
		}
		CString strOldPath = GetItemFileName(ItemDrag);
		// t@C{̂ړ
		if (strNewPath != strOldPath) {
			bResult = ::OperateFile(strOldPath, strNewPath, FO_MOVE, FOF_ALLOWUNDO | FOF_MULTIDESTFILES);
		}
		if (bResult) {
			// WXgύX
			// }
			CFavoritesOrder  order;
			order.LoadOrder(strItemDropFolder);
			int nInsertIndex = bInsertItem ? nItemDropIndex : order.GetCount();
			order.Insert(nInsertIndex, strNewPath);
			order.SaveOrder();

			// 폜
			CFavoritesOrder  order2;
			CString strItemDragFolder = GetItemFileName(ItemDragParent);
			order2.LoadOrder(strItemDragFolder);
			order2.Delete(nItemDragIndex);
			order2.SaveOrder();
		}
	}
	if (!bResult) {
		return FALSE;
	}

	if (bInsertItem) {
		// ړ̈ʒuɃACeǉ
		HTREEITEM hInsertAfter = GetPrevSiblingItem(ItemDrop);
		if (hInsertAfter == NULL) {
			hInsertAfter = TVI_FIRST;
		}

		int 		nImage, nImageS;
		GetItemImage(ItemDrag, nImage, nImageS);
		CString 	strItemText = GetItemText(ItemDrag);

		HTREEITEM	item = InsertItem(strItemText, nImage, nImageS, ItemDropFolder, hInsertAfter);
		if (ItemIsFolder(ItemDrag)) {
			InsertItem( _T("no child"), m_iIconN, m_iIconS, item, TVI_LAST);
		}
	}else {
		// tH_̍ēǂݍ
		LockWindowUpdate();
		AddFolder( strItemDropFolder, ItemDropFolder );
		UnlockWindowUpdate();
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CFavoritesTreeDropTarget
//////////////////////////////////////////////////////////////////////

/// hbO
DROPEFFECT CFavoritesTreeDropTarget::OnDragOver(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{
	BOOL	  bItemInsert = FALSE;
	HTREEITEM item		  = m_pTreeWnd->HitTest(point);
	if (!item) {
		// hbvs̈
		return DROPEFFECT_NONE;
	}

	// ACȅ㔼̗̈擾
	CRect rect;
	m_pTreeWnd->GetItemRect(item, &rect, FALSE);
	rect.bottom = (rect.bottom + rect.top) / 2 - 1;

	if (g_Options.FavoritesIERegist && g_Options.FavoritesOperateOrder) {
		// IE 
		if (((CFileTreeCtrl*)m_pTreeWnd)->ItemIsFolder(item)) {
			if (rect.PtInRect(point)) {
				bItemInsert = TRUE;
			}
		} else {
			bItemInsert = TRUE;
		}

		if (bItemInsert) {
			m_pTreeWnd->SelectDropTarget(NULL);
			m_pTreeWnd->SetInsertMark(item, FALSE);
		} else {
			m_pTreeWnd->SelectDropTarget(item);
			m_pTreeWnd->SetInsertMark(NULL, FALSE);
		}
	} else {
		// \[g
		return CFileTreeDropTarget::OnDragOver(pWnd, pDataObject, dwKeyState, point);
	}

	// XN[
	// 㑤
	if (item == m_pTreeWnd->GetFirstVisibleItem() && rect.PtInRect(point)) {
		HTREEITEM itemPrev = m_pTreeWnd->GetPrevVisibleItem(item);
		if (itemPrev) {
			m_pTreeWnd->EnsureVisible(itemPrev);
		}
	}

	// 
	int nVisibleCount = m_pTreeWnd->GetVisibleCount();
	int nItemHeight   = m_pTreeWnd->GetItemHeight();

	if (point.y > nItemHeight * (nVisibleCount - 1)) {
		HTREEITEM itemNext = m_pTreeWnd->GetNextSiblingItem(item);
		if (itemNext == NULL) {
			itemNext = m_pTreeWnd->GetNextSiblingItem(m_pTreeWnd->GetParentItem(item));
		}
		if (itemNext) {
			m_pTreeWnd->EnsureVisible(itemNext);
		}
	}

	return DROPEFFECT_COPY;
}

/// hbv
DROPEFFECT CFavoritesTreeDropTarget::OnDropEx(CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint point)
{
	DROPEFFECT	result = DROPEFFECT_NONE;

	// ёւł͂Ȃ
	CLIPFORMAT	nClipboardFormatBura = CLIPFORMAT( RegisterClipboardFormat( _T("Bura.TreeItem")) );
	BOOL		bBuraTreeItem		 = pDataObject->IsDataAvailable(nClipboardFormatBura);
	if (!bBuraTreeItem || !g_Options.FavoritesOperateOrder) {
		return CFileTreeDropTarget::OnDropEx(pWnd, pDataObject, dropDefault, dropList, point);
	}

	// c[hbṽc[ACe擾
	CFileTreeCtrl* pTree = (CFileTreeCtrl*)m_pTreeWnd;
	HTREEITEM	   item  = pTree->HitTest(point);

	// hbNACe擾
	HGLOBAL   hData    = pDataObject->GetGlobalData( CLIPFORMAT(RegisterClipboardFormat( _T("Bura.TreeItem"))) );
	HTREEITEM itemDrag = *(HTREEITEM *)GlobalLock(hData);
	GlobalUnlock(hData);
	::GlobalFree(hData);

	if (pTree->OnDropItem(item, itemDrag)) {
		result = DROPEFFECT_MOVE;
	}

	// hbvnCCg
	m_pTreeWnd->SetInsertMark(NULL, FALSE);
	m_pTreeWnd->SelectDropTarget(NULL);

	return result;
}
