/////////////////////////////////////////////////////////////////////////////
// SidebarTablist.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "patriotGlobal.h"
#include "SidebarTablist.h"
#include "MainFrm.h"
#include "UrllistFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSidebarTablist

/// ftHgERXgN^
CSidebarTablist::CSidebarTablist()
	: m_pTabs(NULL)
	, m_Images()
	, m_PosCur()
	, m_Font()
	, m_bChangedTab(FALSE)
	, m_DragItem(-1)
	, m_curIndex(-1)
{
	//+++ m_bChangedTab = FALSE;	//+++ Lɗ.
}

/// fXgN^
CSidebarTablist::~CSidebarTablist()
{
}


BEGIN_MESSAGE_MAP(CSidebarTablist, CListCtrl)
	//{{AFX_MSG_MAP(CSidebarTablist)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_CONTEXTMENU()
	ON_WM_MBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_SIDEBAR_CLOSE 			, OnSidebarClose)
	ON_COMMAND(ID_SIDEBAR_REFRESH			, OnSidebarRefresh)
	ON_COMMAND(ID_SIDEBAR_STOP				, OnSidebarStop)
	ON_COMMAND(ID_SIDEBAR_CLOSESELECTED 	, OnSidebarCloseSelected)
	ON_COMMAND(ID_SIDEBAR_REFRESHSELECTED	, OnSidebarRefreshSelected)
	ON_COMMAND(ID_SIDEBAR_STOPSELECTED		, OnSidebarStopSelected)
	ON_COMMAND(ID_SIDEBAR_REVERSESELECTED	, OnSidebarReverseSelected)
	ON_COMMAND(ID_SIDEBAR_SAVESELECTED		, OnSidebarSaveSelected)
	ON_COMMAND(ID_SIDEBAR_SAVECLOSESELECTED , OnSidebarSaveCloseSelected)
	ON_COMMAND(ID_SIDEBAR_COPYTITLEURL		, OnSidebarCopyTitleurl)
	ON_COMMAND(ID_SIDEBAR_SELECTALL 		, OnSidebarSelectAll)
	ON_COMMAND(ID_SIDEBAR_SELECTCLEAR		, OnSidebarSelectClear)
	ON_COMMAND(ID_SIDEBAR_SELECTDOMAIN		, OnSidebarSelectDomain)
	ON_COMMAND(ID_WINDOW_SORTURL			, OnWindowSorturl)
	ON_COMMAND(ID_FILE_CLOSELEFT			, OnFileCloseleft)	//+++
	ON_COMMAND(ID_FILE_CLOSERIGHT			, OnFileCloseright)	//+++
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSidebarTablist bZ[W nh

/// f[^SĕύX
void CSidebarTablist::LoadData()
{
	for (int i = 0; i < m_pTabs->count(); i++) {
		LoadIndex(i);
	}
}

/// wӏ̂ݕύX
void CSidebarTablist::LoadIndex(int Index)
{
	m_bChangedTab 		= TRUE;
	CMainFrame* pFrame	= (CMainFrame*)AfxGetMainWnd();
	TC_ITEM 	TabItem = {0};
	TabItem.mask 		= TCIF_IMAGE;
	pFrame->m_wndTabBar.GetItem(Index, &TabItem);

	// ACRݒ
	SetItem(Index, 0, LVIF_IMAGE, _T(""), TabItem.iImage, 0, 0, 0);

	// ^Cgݒ
	TCHAR str[MAX_PATH];
	m_pTabs->view(Index)->GetParent()->GetWindowText( str, MAX_PATH );
	SetItemText( Index , 0, str );

	if (Index == pFrame->m_wndTabBar.GetCurSel()) {
		SetHotItem(Index);
		SetCurrentItem(Index);	//+++
	}

	m_bChangedTab = FALSE;
}

/// I𒆂̃ACeɃR}h𑗂
void CSidebarTablist::SendCommandToSelected(UINT Command)
{
	POSITION pos = GetFirstSelectedItemPosition();
	if (pos == NULL) {
	   TRACE0( "No items were selected!\n" );
	} else {
	   while (pos) {
		  int nItem = GetNextSelectedItem(pos);
		  m_pTabs->view(nItem)->PostMessage(WM_COMMAND , Command);
	   }
	}
}

/// ݂̃ACeɃR}h𑗂
void CSidebarTablist::SendCommandToCurrent(UINT Command)
{
	UINT flag = LVHT_ONITEMLABEL | LVHT_ONITEMICON;
	int Index = HitTest(m_PosCur, &flag);

	if (Index>=0) {
		m_pTabs->view(Index)->PostMessage( WM_COMMAND, Command );
	}
}

/// }EX̃ACe擾
int CSidebarTablist::HitTestItem(CPoint point)
{
	CPoint pos;
	CRect  rect;
	GetWindowRect(rect);
	pos.x = point.x - rect.left;
	pos.y = point.y - rect.top;

	UINT flag = LVHT_ONITEMLABEL | LVHT_ONITEMICON | LVHT_TOLEFT;
	return HitTest(point, &flag);
}

/// \z
int CSidebarTablist::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CListCtrl::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}

	// Colum̒ǉ
	InsertColumn(0, _T("^Cg")	, LVCFMT_LEFT , lpCreateStruct->cx);
	SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// C[W̃[h
	CMainFrame* pMainFrame = static_cast<CMainFrame*>( AfxGetMainWnd() );
	//ASSERT(pMainFrame != NULL);	//+++ vc6ł͑vȂ̂ vc7(.1)ȍ~NULLɂȂ(AfxGetMainWnd()NULLɂȂĂ܂).
	if ( pMainFrame == 0			//+++ `FbNǉ
		|| pMainFrame->m_wndTabBar.m_Images.GetImageCount() == 0)
	{
		CString strBmpPath = g_Options.strAppPath+ _T("\\res\\tab.bmp");
		CBitmap BMP_Tool;
		HBITMAP BMP_baf;
		m_Images.Create(12, 12, ILC_MASK | ILC_COLOR32, 0, 7);
		BMP_baf = ( HBITMAP )::LoadImage(NULL , strBmpPath, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		BMP_Tool.Attach(BMP_baf);
		m_Images.Add(&BMP_Tool , RGB(255, 0, 255));
		SetImageList(&m_Images , LVSIL_SMALL);
		BMP_Tool.DeleteObject();
	} else {
		SetImageList(&pMainFrame->m_wndTabBar.m_Images, LVSIL_SMALL);
	}
	return 0;
}

/// ACe̕ύX
void CSidebarTablist::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult)
{
	//+++ NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	/*
	if (m_bChangedTab || GetAsyncKeyState(VK_SHIFT) || GetAsyncKeyState(VK_CONTROL))
		return;
	*/
	/*
	if (pNMListView->iItem>=0) {
		m_bChangedTab = TRUE;
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		if (pFrame->MDIGetActive()!=NULL && m_pTabs->count()>0 && pNMListView->iItem>=0 && m_pTabs->view(pNMListView->iItem)) {
			pFrame->SetTab(pNMListView->iItem);
		}
		SetFocus();
		m_bChangedTab = FALSE;
	}
	*/
	*pResult = 0;
}

/// tH[JX
void CSidebarTablist::OnSetFocus(CWnd* pOldWnd)
{
	CListCtrl::OnSetFocus(pOldWnd);
	//+++ SetCurrentItem(m_curIndex);			//+++ ς.
}

/// }EXړ
void CSidebarTablist::OnMouseMove(UINT nFlags, CPoint point)
{
	static HCURSOR cursor = SetCursor(GetCursor());
  #if 1	//+++
	int index = HitTestItem(point);
	if (index >= 0)
		m_curIndex = index;
	if (!(nFlags & MK_LBUTTON)) {
		m_DragItem = -1;
		SetCursor(cursor);
	} else if (index != m_DragItem) {
		SetCursor(GetHotCursor());
	}
  #else
	if (!(nFlags & MK_LBUTTON)) {
		m_DragItem=-1;
		SetCursor(cursor);
	} else if (HitTestItem(point)!=m_DragItem) { // hbO
		SetCursor(GetHotCursor());
	}
  #endif
	CListCtrl::OnMouseMove(nFlags, point);
}

/// hbOJn
void CSidebarTablist::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_DragItem = HitTestItem(point);

	if (!(nFlags & (MK_CONTROL | MK_SHIFT))) {
		m_bChangedTab = TRUE;
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		if (pFrame->MDIGetActive()!=NULL && m_pTabs->count() > 0 && m_DragItem>=0 && m_pTabs->view(m_DragItem)) {
			pFrame->SetTab(m_DragItem);
		}
		SetFocus();
		m_bChangedTab = FALSE;
	}

	CListCtrl::OnLButtonDown(nFlags, point);
}

/// hbv
void CSidebarTablist::OnLButtonUp(UINT nFlags, CPoint point)
{
	CListCtrl::OnLButtonUp(nFlags, point);
	int Index = HitTestItem(point);
	if (Index < 0 || Index>=GetItemCount()) {
		return;
	}

	if (m_DragItem != Index && m_DragItem>-1) {
		SetItemState(m_DragItem , 0 , LVIS_SELECTED);
		// ^u}
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		pFrame->SendMessage(WM_INSERTTAB , m_DragItem , Index);
		// tH[JX
	  #if 1	//+++
		SetCurrentItem(Index);
	  #else
		SetItemState(Index , 2 , LVIS_SELECTED);
	  #endif
		SetSelectionMark(Index);
	}
}

/// {^
void CSidebarTablist::OnMButtonDown(UINT nFlags, CPoint point)
{
	int Index = HitTestItem(point);
	// I̔]
	if (Index>=0) {
		UINT state;
		state = GetItemState(Index , LVIS_SELECTED);
		SetItemState(Index, ~state, LVIS_SELECTED);
	}

	CListCtrl::OnMButtonDown(nFlags, point);
}

/// ENbN
void CSidebarTablist::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu menu;
	menu.LoadMenu(IDR_SIDEBARTAB);
	CRect rect;
	GetWindowRect(rect);
	m_PosCur.x = point.x-rect.left;
	m_PosCur.y = point.y-rect.top;
	menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON , point.x , point.y , this , NULL);
	menu.Detach();
}

/// ̃^u
void CSidebarTablist::OnSidebarClose()
{
	SendCommandToCurrent(ID_FILE_CLOSE);
}

/// ̃^uXV
void CSidebarTablist::OnSidebarRefresh()
{
	SendCommandToCurrent(ID_VIEW_REFRESH);
}

/// ̃^u
void CSidebarTablist::OnSidebarStop()
{
	SendCommandToCurrent(ID_VIEW_STOP);
}

/// I^u
void CSidebarTablist::OnSidebarCloseSelected()
{
	if (g_Options.bAlertSelected && AfxMessageBox( _T("Iꂽ^u܂B")  , MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL) {
		return;
	}

	SendCommandToSelected(ID_FILE_CLOSE);
}

/// I^uXV
void CSidebarTablist::OnSidebarRefreshSelected()
{
	SendCommandToSelected(ID_VIEW_REFRESH);
}

/// I^u𒆎~
void CSidebarTablist::OnSidebarStopSelected()
{
	SendCommandToSelected(ID_VIEW_STOP);
}

/// ׂđI
void CSidebarTablist::OnSidebarSelectAll()
{
	for (int i = 0;i<m_pTabs->count();i++) {
		SetItemState(i , 2 , LVIS_SELECTED);
	}
}

/// INA
void CSidebarTablist::OnSidebarSelectClear()
{
	for (int i = 0; i < m_pTabs->count(); i++) {
		SetItemState(i , 0 , LVIS_SELECTED);
	}
}

/// I^u𔽓]
void CSidebarTablist::OnSidebarReverseSelected()
{
	UINT state;
	for (int i = 0;i<m_pTabs->count();i++) {
		state = GetItemState(i , LVIS_SELECTED);
		SetItemState(i, ~state, LVIS_SELECTED);
	}
}

/// hCI
void CSidebarTablist::OnSidebarSelectDomain()
{
	CString strURL;
	LockWindowUpdate();
	POSITION pos = GetFirstSelectedItemPosition();
	if (pos == NULL) {
		TRACE0( "No items were selected!\n" );
	} else {
	   while (pos){
		  int nItem = GetNextSelectedItem(pos);
		  strURL = m_pTabs->view(nItem)->GetLocationURL();
	   }
	}
	// hĈݐ؂o
	strURL = strURL.Left(strURL.Find( _T("/")  , 9));
	for (int i = 0;i<m_pTabs->count();i++) {
		if (m_pTabs->view(i)->GetLocationURL().Left(strURL.GetLength()) == strURL) {
			SetItemState( i, 2, LVIS_SELECTED );
		}
	}
	UnlockWindowUpdate();
}

/// I^uۑ
void CSidebarTablist::OnSidebarSaveSelected()
{
	CString strFileName = GetStrFromFileDlg( FALSE, _T(".bul"), _T(""), OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("URLXg(*.bul)\0*.bul\0"), g_Options.strUrllistPath );

	CString str = _T(""), str2;
	//+++ CPatriotApp* pApp = static_cast<CPatriotApp*>( AfxGetApp() );
	if (strFileName.IsEmpty()) {// hozon
		return;
	}

	CUrllistFile file;
	for (int i = 0;i < m_pTabs->count(); i++) {
		if (GetItemState( i, LVIS_SELECTED )) {
			file.AddView( m_pTabs->view(i) );
		}
	}
	file.Save( strFileName );
	/*
	CStdioFile fin( strFileName, CFile::modeCreate | CFile::modeWrite );

	TCHAR chrSetting[13] = _T("22222222222\n");
	for (int i = 0;i < m_pTabs->count(); i++) {
		if (GetItemState( i, LVIS_SELECTED )) {
			fin.WriteString( m_pTabs->view(i)->GetLocationURL() + _T("\n") );
			m_pTabs->view(i)->SendMessage( WM_LOADSTRSETTING, (int)chrSetting );
			fin.WriteString(chrSetting);
			fin.WriteString( _T("\n") );
		}
	}
	fin.Close();
	*/

	// URL Xgēǂݍ
	CMainFrame* pMainFrame = static_cast<CMainFrame*>( AfxGetMainWnd() );
	pMainFrame->m_wndSideBar.m_TreeUrllist.SendMessage( WM_COMMAND, ID_SIDEBAR_REFRESHALL, 0 );
}

/// I^uۑĕ
void CSidebarTablist::OnSidebarSaveCloseSelected()
{
	OnSidebarSaveSelected();
	OnSidebarCloseSelected();
}

/// ^CgURLRs[
void CSidebarTablist::OnSidebarCopyTitleurl()
{
	CString str;
	for (int i = 0;i<m_pTabs->count();i++) {
		if (GetItemState(i , LVIS_SELECTED)) {
			str += m_pTabs->view(i)->GetLocationName()+ _T("\x0d\x0a");
			str += m_pTabs->view(i)->GetLocationURL() + _T("\x0d\x0a");
			str += _T("\x0d\x0a");
		}
	}
	SetClipboardText(str);
}

/// URL Ń\[g
void CSidebarTablist::OnWindowSorturl()
{
	AfxGetMainWnd()->SendMessage(WM_COMMAND , ID_WINDOW_SORTURL);
}

/*
void CSidebarTablist::OnSidebarTileV()
{ // ㉺ɕׂ
	if ( m_pTabs->count() == 0 || GetSelectedCount() < 2)
		return;
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
	if (pMainFrame->MDIGetActive()->IsZoomed())
		pMainFrame->MDICascade();
	else if (g_Options.TabMode) {
		g_Options.TabMode = FALSE;
		pMainFrame->MDICascade();
	}

	CRect rectMax = CalcMainClientRect();

	int ChildHeight = rectMax.bottom / GetSelectedCount();
	CRect rect = rectMax;
	rect.bottom = ChildHeight*GetSelectedCount();
	rect.top = rect.bottom-ChildHeight-GetSystemMetrics(SM_CYCAPTION)-4;

	for (int i = m_pTabs->count()-1;i>-1;i--) {
		if (GetItemState(i , LVIS_SELECTED) == 2) {
			m_pTabs->view(i)->GetParent()->SetWindowPos(&wndTop , rect.left , rect.top , rect.Width() , rect.Height() , NULL);
			rect.top-=ChildHeight;
			rect.bottom-=ChildHeight;
		}
	}
}

void CSidebarTablist::OnSidebarTileH()
{ // Eɕׂ
	if ( m_pTabs->count() == 0 || GetSelectedCount() < 2)
		return;

	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
	if (pMainFrame->MDIGetActive()->IsZoomed())
		pMainFrame->MDICascade();
	else if (g_Options.TabMode) {
		g_Options.TabMode = FALSE;
		pMainFrame->MDICascade();
	}

	CRect rectMax = CalcMainClientRect();

	int ChildWidth = rectMax.right / GetSelectedCount();
	CRect rect = rectMax;
	rect.right = ChildWidth;

	for (int i = 0;i<m_pTabs->count();i++) {
		if (GetItemState(i , LVIS_SELECTED) == 2) {
			m_pTabs->view(i)->GetParent()->SetWindowPos(&wndTop , rect.left , rect.top , rect.Width() , rect.Height() , NULL);
			rect.left += ChildWidth;
			rect.right += ChildWidth;
		}
	}

}
*/

/*
	HRESULT hRes = ::CoInitialize(NULL);
	if ( hRes == E_OUTOFMEMORY )
		return ;
	if ( hRes == E_INVALIDARG )
		return ;
	if ( hRes == E_UNEXPECTED )
		return ;

	IPersistFile* presistFile;
	GetHtmlDocument()->QueryInterface(IID_IPersistFile, (void **)&presistFile);
	CString str= _T("c:\\test.htm");
	presistFile->Save(str.AllocSysString() , TRUE);
*/


/// PreTranslateMessage
BOOL CSidebarTablist::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN && !(GetKeyState(VK_SHIFT) & 0x8000) && !(GetKeyState(VK_CONTROL)	& 0x8000)) {
		int iItem = GetNextItem( -1, LVNI_ALL | LVNI_SELECTED );
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		if (pFrame->MDIGetActive() != NULL && m_pTabs->count() > 0 && iItem >= 0 && m_pTabs->view(iItem)) {
			pFrame->SetTab(iItem);
		}
//		SetFocus();
	}
	return CListCtrl::PreTranslateMessage(pMsg);
}

/// ő剻Ƃ̗̈vZ
CRect CSidebarTablist::CalcMainClientRect()
{
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
	CRect 		rect;
	pMainFrame->GetClientRect(rect);
	rect.top=-GetSystemMetrics(SM_CYCAPTION)-4;rect.bottom += 2;rect.left=-4;rect.right += 4;
	// o[TCY擾
	if (pMainFrame->m_wndReBar.IsWindowVisible()) {// rebar
		rect.bottom-=pMainFrame->m_wndReBar.GetReBarCtrl().GetBarHeight();
	}
	if (g_Options.TabUnder) {// tabbar
		rect.bottom-=pMainFrame->m_wndReBar2.GetReBarCtrl().GetBarHeight()+1;
	}
	if (pMainFrame->m_wndStatusBar.IsWindowVisible()) { // status
		CRect rect2;
		pMainFrame->m_wndStatusBar.GetClientRect(rect2);
		rect.bottom-=rect2.bottom;
	}
	if (pMainFrame->m_wndSideBar.IsWindowVisible() && !g_Options.SidebarNeglectWidth) {// sidebar
		rect.right-=pMainFrame->m_wndSideBar.GetWidth();
	}
	return rect;
}


#if 1	//+++ ǉ.
/// ̃^u
void CSidebarTablist::OnFileCloseleft()
{
	int curIndex = m_curIndex;	//GetCursorPosItem();
	if (curIndex < 0)
		return;

	if (g_Options.bAlertCloseExcept) {
		int nResult = AfxMessageBox( _T("̃^u܂B"), MB_OKCANCEL | MB_ICONQUESTION, 0);
		if (nResult == IDCANCEL) {
			return;
		}
	}

	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	pFrame->LockTabUpdate();
	for (int i = 0; i < curIndex; i++) {
		m_pTabs->view(0)->SendMessage( WM_COMMAND, ID_FILE_CLOSE );
	}
	pFrame->UnlockTabUpdate();
}

/// ̃^u艺
void CSidebarTablist::OnFileCloseright()
{
	int curIndex = m_curIndex;	//GetCursorPosItem();
	if (curIndex < 0)
		return;

	if (g_Options.bAlertCloseExcept) {
		int nResult = AfxMessageBox( _T("̃^u艺܂B"), MB_OKCANCEL | MB_ICONQUESTION, 0);
		if (nResult == IDCANCEL) {
			return;
		}
	}

	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	pFrame->LockTabUpdate();
	for (int i = m_pTabs->count() - 1; i > curIndex; i--) {
		m_pTabs->view(i)->PostMessage( WM_COMMAND, ID_FILE_CLOSE );
	}
	pFrame->UnlockTabUpdate();
}

#if 0	//+++ s.
int CSidebarTablist::GetCursorPosItem()
{
	CPoint pt;
	::GetCursorPos(&pt);
	ScreenToClient( &pt );
	int index = HitTest( pt );
	//int index = HitTestItem(pt);
	if (index < 0 || index >= GetItemCount()) {
		index = m_curIndex;
	}
	return index;
}
#endif
#endif

#if 1	//+++ ǉ
/// TCho[^OXg̃Jg^uʒuύX.
void CSidebarTablist::SetCurrentItem(int index)
{
	//if (index != m_curIndex)
	{
		//CListCtrl::SetItemState(m_curIndex, 0, LVIS_SELECTED | LVIS_FOCUSED);
		OnSidebarSelectClear();		//+++ S̃}[NO... \SĂƕs?
		CListCtrl::SetItemState(index, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
		//CListCtrl::SetHotItem(index);
		//SetSelectionMark(index);
		m_curIndex = index;
	}
}
#endif
#if 0	//+++ ǉ 
/// TCho[^OXg̃Jg^uʒuύX.
void CSidebarTablist::ClearCurrentItem()
{
	{
		OnSidebarSelectClear();
		//CListCtrl::SetItemState(m_curIndex, 0, LVIS_SELECTED | LVIS_FOCUSED);
		m_curIndex = -1;
	}
}
#endif
