/////////////////////////////////////////////////////////////////////////////
// TabThumbnailDlg.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "TabThumbnailDlg.h"
#include "burapi.h"
#include "MainFrm.h"
#include "patriotView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabThumbnailDlg _CAO

/// RXgN^
CTabThumbnailDlg::CTabThumbnailDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTabThumbnailDlg::IDD, pParent)
	, m_ImageCount(0)
	, m_ImageIndex(0)
	, m_ImageWidth(0)
	, m_ImageHeight(0)
	, m_ImageNumberKeyStart(0)
	, m_ImageXCount(0)
	, m_ImageYCount(0)
	, m_ImageArray(0)
	, m_Font()
	, m_bDrawImage(0)
{
	//{{AFX_DATA_INIT(CTabThumbnailDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}

///
void CTabThumbnailDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabThumbnailDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabThumbnailDlg, CDialog)
	//{{AFX_MSG_MAP(CTabThumbnailDlg)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTabThumbnailDlg bZ[W nh

/// TlCk
UINT CTabThumbnailDlg::StretchTabImage(LPVOID Param)
{
	CoInitialize(NULL);

	StretchParam* pParam		 = static_cast<StretchParam*>(Param);

	CMDIFrameWnd* pMainFrame	 = (CMDIFrameWnd*)CWnd::FromHandle(pParam->hMainFrame);
	CRect		  rect			 = pParam->clientRect;
	LPSTREAM*	  StreamPtrArray = pParam->StreamPtrArray;

	// TlC
	TabImage*	  ImageArray	= pParam->pDlg->m_ImageArray;
	int 		  ImageCount	= pParam->pDlg->m_ImageCount;
	int 		  ImageHeight	= pParam->pDlg->m_ImageHeight;
	int 		  ImageWidth	= pParam->pDlg->m_ImageWidth;

	// TlCꎞۑ
	CClientDC dc(pMainFrame);

	// TlCk
	for (int Index = 0; Index < ImageCount; Index++) {
		CString strMessage;
		strMessage.Format(_T("TlC쐬(%d/%d)..."), Index, ImageCount);
		pMainFrame->SetMessageText(strMessage);

		// bitmap쐬
		ImageArray[Index].Bitmap.CreateCompatibleBitmap(&dc, ImageWidth, ImageHeight);
		CDC 	 dcBitmap;
		dcBitmap.CreateCompatibleDC(NULL);
		CBitmap* bmpOld = dcBitmap.SelectObject(&ImageArray[Index].Bitmap);

		// Rs[
		CComPtr<IDispatch> spDisp;
		HRESULT hr = ::CoGetInterfaceAndReleaseStream(StreamPtrArray[Index], IID_IDispatch, (void**)&spDisp);
		if (hr == S_OK) {
			rect = CRect(0, 0, ImageWidth, ImageHeight);
			::OleDraw(spDisp, DVASPECT_CONTENT, dcBitmap.m_hDC, rect);
		}
		dcBitmap.SelectObject(bmpOld);
	}

	delete[] StreamPtrArray;

	pParam->pDlg->RedrawWindow();
	delete pParam;

	pMainFrame->SetMessageText(_T(""));

	CoUninitialize();
	return 0;
}

/// Tl[쐬
BOOL CTabThumbnailDlg::LoadTabImage()
{
	CMainFrame* pMainFrame = (CMainFrame*)GetParent();

	CRect rect;
	static_cast<CPatriotView*>(pMainFrame->MDIGetActive()->GetActiveView())->m_wndBrowser.GetClientRect(rect);
	// TlC
	m_ImageCount = pMainFrame->m_Tabs.count();
	m_ImageArray = new TabImage[m_ImageCount];

	m_ImageHeight = m_ImageWidth * rect.Height() / rect.Width();

	// OLEDrawTest
	LPSTREAM* StreamPtrArray = new LPSTREAM[m_ImageCount];
	for (int Index = 0; Index < m_ImageCount; Index++) {
		CHtmlView2* 		pView  = pMainFrame->m_Tabs.view(Index);
		CComPtr<IDispatch>	spDisp = pView->GetHtmlDocument();
		::CoMarshalInterThreadInterfaceInStream(IID_IDispatch, spDisp, &StreamPtrArray[Index]);

		m_ImageArray[Index].strTitle = pView->GetLocationName();
	}
	// kXbhN
	StretchParam* Param   = new StretchParam;
	Param->pDlg 		  = this;
	Param->hMainFrame	  = pMainFrame->m_hWnd;
	Param->StreamPtrArray = StreamPtrArray;
	Param->clientRect	  = rect;

	AfxBeginThread(StretchTabImage, Param);
	return TRUE;
}


#if 0
/// ^ũC[W쐬(XP)
BOOL CTabThumbnailDlg::LoadTabImageByPrintWindow(CBitmap* pTempBitmap , BOOL bUseApi)
{
	HMODULE hModule;
	typedef void (WINAPI PRINTWINDOW)(HWND hwnd, HDC dc, UINT flags);
	PRINTWINDOW* lpPrintWindowFunc;
	if (bUseApi) { // DLL̓ǂݍ
		hModule= (HMODULE)AfxLoadLibrary(_T("USER32.dll"));
		if (!hModule) {
			return FALSE;
		}
		lpPrintWindowFunc = (PRINTWINDOW*)GetProcAddress(hModule ,	_T("PrintWindow"));
		if (!lpPrintWindowFunc){
			return FALSE;
		}
	}
	CMainFrame* pMainFrame = (CMainFrame*)GetParent();
	CClientDC dc(pMainFrame);

	for (int Index = 0 ; Index < m_ImageCount ; Index++) {
		CString strMessage;
		strMessage.Format(_T("C[W擾(%d/%d)..."), Index , m_ImageCount);
		pMainFrame->SetMessageText(strMessage);

		CHtmlView2* pView = pMainFrame->m_Tabs.view(Index);
		// ^Cg擾
		m_ImageArray[Index].strTitle = pView->GetLocationName();
		// View
		CWnd* pWndBrowser = &pView->m_wndBrowser;
		CRect rect;
		pWndBrowser->GetClientRect(rect);
		CDC dcBrowser;
		dcBrowser.CreateCompatibleDC(&dc);
		CBitmap bmpBuffer;
		bmpBuffer.CreateCompatibleBitmap(&dc , rect.Width() , rect.Height());
		CBitmap* bmpBrowserOld = (CBitmap*)dcBrowser.SelectObject(bmpBuffer);

		// Rs[obt@Ɏs
		if (bUseApi) {
			LPDISPATCH pDisp = ((CPatriotView*)pView)->GetApplication();
			::OleDraw(pDisp, DVASPECT_CONTENT, dcBrowser.m_hDC, rect);
			pDisp->Release();
		} else {
			pWndBrowser->SendMessage(WM_PRINT, (WPARAM)dcBrowser.m_hDC, /*PRF_NONCLIENT | */PRF_CLIENT | PRF_CHILDREN /*| PRF_ERASEBKGND */);
		}

		// bitmap쐬
		pTempBitmap[Index].CreateCompatibleBitmap(&dc , rect.Width() , rect.Height());
		CDC dcBitmap;
		dcBitmap.CreateCompatibleDC(NULL);
		CBitmap* bmpBitmapOld = (CBitmap*)dcBitmap.SelectObject(pTempBitmap[Index]);
		// Rs[
		dcBitmap.BitBlt(0, 0, rect.Width(), rect.Height(), &dcBrowser, 0, 0, SRCCOPY);

		dcBitmap.SelectObject(bmpBitmapOld);
		dcBrowser.SelectObject(bmpBrowserOld);
	}

	if (bUseApi) {
		AfxFreeLibrary(hModule);
	}
	return TRUE;
	// SetWindowLong(pView->GetParent()->m_hWnd, GWL_EXSTYLE, GetWindowLong(pView->GetParent()->m_hWnd, GWL_EXSTYLE) | WS_EX_LAYERED);
	// ::SetLayeredWindowAttributes(pView->GetParent()->m_hWnd, 0, 90, ULW_ALPHA);
}
#endif

/// ݂IndexɃWv
void CTabThumbnailDlg::JumpToIndex()
{
	CRect rect;
	GetClientRect(rect);
	if (m_ImageXCount ==0) {
		return;
	}

	int MarginY = 20;
	int Y = m_ImageIndex / m_ImageXCount;

	int ScrollY = (m_ImageHeight + MarginY) * Y + MarginY - (rect.Height() - m_ImageHeight) /2;
	if (ScrollY < 0) {
		ScrollY = 0;
	}
	SetScrollPos(SB_VERT , ScrollY);
	RedrawWindow();
}

/// Index̃TlCANeBuȃ^u
void CTabThumbnailDlg::SetIndexTabActive()
{
	if (m_ImageIndex > -1 && m_ImageIndex < m_ImageCount) {
		int nActiveTab = int( AfxGetMainWnd()->SendMessage(BURAPI_GETACTIVETAB) );

		if (nActiveTab != m_ImageIndex) {
			AfxGetMainWnd()->SendMessage(BURAPI_SETACTIVETAB, m_ImageIndex);
		}
		EndDialog(IDOK);
	}
}

/// _CAO
BOOL CTabThumbnailDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ݒ̓ǂݍ
	m_ImageIndex = -1;
	m_ImageWidth = m_ImageHeight = g_Options.ThumbnailSize;
	m_bDrawImage = !g_Options.ThumbnailNoImage;

	// tHgݒ
	//m_Font.CreatePointFont(90, _T("lr SVbN"));
	NONCLIENTMETRICS ncm;
	ncm.cbSize = sizeof(NONCLIENTMETRICS);
	VERIFY(SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, 0));
	m_Font.CreateFontIndirect(&ncm.lfMessageFont);

	// XN[o[
	SetScrollRange(SB_VERT, 0, 0);

	// EBhETCY
	int nWidth	= AfxGetApp()->GetProfileInt(_T("Thumbnail"), _T("WindowWidth"),  640);
	int nHeight = AfxGetApp()->GetProfileInt(_T("Thumbnail"), _T("WindowHeight"), 480);

	RECT rect = {0};
	GetDesktopWindow()->GetWindowRect(&rect);
	rect.left	= (rect.right - nWidth) / 2;
	rect.right	= (rect.right + nWidth) / 2;
	rect.top	= (rect.bottom - nHeight) / 2;
	rect.bottom = (rect.bottom + nHeight) / 2;

	MoveWindow(&rect , FALSE);

	// TlC쐬
	LoadTabImage();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// j
void CTabThumbnailDlg::OnDestroy()
{
	// EBhETCY
	CRect rect;
	GetWindowRect(rect);
	AfxGetApp()->WriteProfileInt(_T("Thumbnail") , _T("WindowWidth") , rect.Width());
	AfxGetApp()->WriteProfileInt(_T("Thumbnail") , _T("WindowHeight") , rect.Height());

	CDialog::OnDestroy();

	delete[] m_ImageArray;
}

/// `
void CTabThumbnailDlg::OnPaint()
{
	CPaintDC	dc(this); // `p̃foCX ReLXg
	CRect		rect;
	GetClientRect(rect);

	// TlC̔zuvZ
	m_ImageXCount = rect.Width() / m_ImageWidth;
	if (m_ImageXCount > m_ImageCount) {
		m_ImageXCount = m_ImageCount;
	}
	if (m_ImageXCount == 0) {
		return;
	}

	m_ImageYCount = int(float(m_ImageCount) / m_ImageXCount + 0.9);

	// ]vZ
	int MarginX = (rect.Width() - m_ImageWidth * m_ImageXCount) / (m_ImageXCount+1);
	if (MarginX < 10) { // Ԋûňi₷
		m_ImageXCount--;
		m_ImageYCount++;
		MarginX += (m_ImageWidth + MarginX) / (m_ImageXCount+1);
	}
	int MarginY = 30;

	int ScrollY = (m_ImageHeight + MarginY) * m_ImageYCount + MarginY - rect.Height();
	if (ScrollY < 0) { // TlCEBhE傫
		ScrollY = ScrollY / 2;
	} else if (GetScrollLimit(SB_VERT) == ScrollY + 1) { // ʏ
		ScrollY = GetScrollPos(SB_VERT);
	} else { // TCYύX
		SetScrollRange(SB_VERT, 0, ScrollY);
		ScrollY = 0;
	}

	// obt@DC̏
	CBitmap bmpBuffer;
	bmpBuffer.CreateCompatibleBitmap(&dc, rect.Width(), rect.Height());

	CDC 	dcBuffer;
	dcBuffer.CreateCompatibleDC(NULL);
	CBitmap* bmpBufferOld = dcBuffer.SelectObject(&bmpBuffer);

	CFont*	FontOld 	  = dcBuffer.SelectObject(&m_Font);
	int 	nBkModeOld	  = dcBuffer.SetBkMode(TRANSPARENT);
	// ver1.4.00 COLOR_3DFACE  COLOR_WINDOW
	dcBuffer.FillSolidRect(rect, GetSysColor(COLOR_WINDOW));

	// TlC`
	int X = 0, Y = 0;
	m_ImageNumberKeyStart = -1;

	for (int i = 0; i < m_ImageCount; i++) {
		m_ImageArray[i].rect.left	= (m_ImageWidth  + MarginX) * X + MarginX ;
		m_ImageArray[i].rect.top	= (m_ImageHeight + MarginY) * Y + MarginY - ScrollY ;
		m_ImageArray[i].rect.right	= m_ImageArray[i].rect.left + m_ImageWidth ;
		m_ImageArray[i].rect.bottom = m_ImageArray[i].rect.top	+ m_ImageHeight +12;

		// V[gJbgL[vZJn
		if (m_ImageNumberKeyStart == -1 && m_ImageArray[i].rect.top > 0) {
			m_ImageNumberKeyStart = i;
		}

		// `ʂ
		if ( m_ImageArray[i].rect.bottom > 0 && m_ImageArray[i].rect.top < rect.bottom) {
			if (i == m_ImageIndex) { // ݑI
				// wi`
				CRect	rectEdge = m_ImageArray[i].rect;
				rectEdge.InflateRect(5, 6);
				dcBuffer.FillSolidRect(rectEdge, RGB(211, 229, 255));

				COLORREF color = RGB(49, 106, 192);
				CBrush brush(color);
				dcBuffer.FrameRect(rectEdge, &brush);
			} else {
				dcBuffer.SetBkColor(GetSysColor(COLOR_3DFACE));
			}

			// ^ũ^Cg
			const int/*+++*/ NUMBER_KEY_MARGIN = 16;
			RECT rectText =  m_ImageArray[i].rect;
			rectText.left += NUMBER_KEY_MARGIN;
			dcBuffer.DrawText(m_ImageArray[i].strTitle, &rectText, DT_SINGLELINE | DT_NOPREFIX | DT_END_ELLIPSIS);
			//dcBuffer.ExtTextOut(m_ImageArray[i].rect.left+16, m_ImageArray[i].rect.top, ETO_CLIPPED | ETO_OPAQUE, m_ImageArray[i].rect, m_ImageArray[i].strTitle, NULL);

			// TlC
			if (m_bDrawImage) {
				CDC 	dcBitmap;
				dcBitmap.CreateCompatibleDC(&dc);
				CBitmap* pOldBmp = dcBitmap.SelectObject(&m_ImageArray[i].Bitmap);
				dcBuffer.BitBlt(m_ImageArray[i].rect.left, m_ImageArray[i].rect.top+12, m_ImageArray[i].rect.Width(), m_ImageArray[i].rect.Height(), &dcBitmap, 0, 0, SRCCOPY);
				dcBitmap.SelectObject(pOldBmp);

				// TlC̘g
				CRect	 rectFrame = m_ImageArray[i].rect;
				rectFrame.top += 11;
				COLORREF color = ::GetSysColor(COLOR_3DDKSHADOW);
				CBrush	 brush(color);
				dcBuffer.FrameRect(&rectFrame, &brush);
			}

			// V[gJbg
			if (m_ImageNumberKeyStart > -1) {
				TCHAR chrKey = (TCHAR)(_T('1') + i - m_ImageNumberKeyStart);

				if (chrKey == _T('9')+1) {
					chrKey = _T('0');
				} else if (chrKey > _T('9')+1) {
					chrKey = (TCHAR)(_T('A') + i - m_ImageNumberKeyStart - 10);
				}

				RECT	 rcNumber = { m_ImageArray[i].rect.left, m_ImageArray[i].rect.top, m_ImageArray[i].rect.left+12, m_ImageArray[i].rect.top+12 };
				CString  str	  = chrKey;
				dcBuffer.DrawText(str, &rcNumber, DT_CENTER | DT_SINGLELINE | DT_VCENTER);
				rcNumber.top	 -= 1;
				//dcBuffer.ExtTextOut(m_ImageArray[i].rect.left + 4, m_ImageArray[i].rect.top, ETO_CLIPPED, &rcNumber, str, NULL);
				COLORREF color	  = ::GetSysColor(COLOR_3DDKSHADOW);
				CBrush	 brush(color);
				dcBuffer.FrameRect(&rcNumber, &brush);
			}
		}

		// CNg
		X++;
		if (X == m_ImageXCount) {
			X=0;
			Y++;
		}
	}

	// obt@_CAOɓ]
	dc.BitBlt(0 , 0, rect.Width() , rect.Height() , &dcBuffer , 0 , 0 , SRCCOPY);
	dcBuffer.SelectObject(bmpBufferOld);
	dcBuffer.SelectObject(FontOld);
	dcBuffer.SetBkMode(nBkModeOld);

	// `pbZ[WƂ CDialog::OnPaint() ĂяoĂ͂܂
}

/// TCYύX
void CTabThumbnailDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	RedrawWindow();
}

/// XN[o[
void CTabThumbnailDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO sri;
	GetScrollInfo(SB_VERT, &sri);
	switch(nSBCode)
	{
	case SB_LINEUP:
		--sri.nPos;
		break;
	case SB_LINEDOWN:
		++sri.nPos;
		break;
	case SB_PAGEUP:
		sri.nPos -= sri.nPage;
		break;
	case SB_PAGEDOWN:
		sri.nPos += sri.nPage;
		break;
	case SB_TOP:
		sri.nPos = sri.nMin;
		break;
	case SB_BOTTOM:
		sri.nPos = sri.nMax;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		sri.nPos = sri.nTrackPos;
		break;
	}
	SetScrollInfo(SB_VERT, &sri);

	// ĕ`
	RedrawWindow();

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

/// wi
BOOL CTabThumbnailDlg::OnEraseBkgnd(CDC* pDC)
{
 //	CDialog::OnEraseBkgnd(pDC);
	return 1;
}

/// }EXI[o[
void CTabThumbnailDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// ANeBuύXčە`
	for (int i=0 ; i < m_ImageCount; i++ ) {
		if (m_ImageArray[i].rect.PtInRect(point)) {
			m_ImageIndex = i;
			RedrawWindow();
			break;
		}
	}
	CDialog::OnMouseMove(nFlags, point);
}

/// NbNCxg
void CTabThumbnailDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_ImageIndex = -1;

	for (int i=0; i < m_ImageCount; i++ ) {
		if (m_ImageArray[i].rect.PtInRect(point)) {
			m_ImageIndex = i;
			break;
		}
	}

	SetIndexTabActive();

	CDialog::OnLButtonDown(nFlags, point);
}

/// }EXzC[
BOOL CTabThumbnailDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) + m_ImageHeight / 4 * ((zDelta > 0) ? -1 : 1));
	RedrawWindow();

	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

/// PreTranslateMessage
BOOL CTabThumbnailDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN) {
		int nChar = (int) pMsg->wParam;

		// \L[
		if (nChar == VK_LEFT && m_ImageIndex > 0) {
			m_ImageIndex--;
			JumpToIndex();
			return TRUE;
		} else if (nChar == VK_RIGHT && m_ImageIndex < m_ImageCount-1) {
			m_ImageIndex++;
			JumpToIndex();
			return TRUE;
		} else if (nChar == VK_UP && m_ImageIndex >= m_ImageXCount) {
			m_ImageIndex -= m_ImageXCount;
			JumpToIndex();
			return TRUE;
		} else if (nChar == VK_DOWN && m_ImageIndex + m_ImageXCount < m_ImageCount) {
			m_ImageIndex += m_ImageXCount;
			JumpToIndex();
			return TRUE;
		// V[gJbgŃ^uI
		} else if (nChar >= _T('1') && nChar <= _T('9')) {
			m_ImageIndex = (nChar - _T('1'))  + m_ImageNumberKeyStart;
			SetIndexTabActive();
			return TRUE;
		} else if (nChar == _T('0')) {
			m_ImageIndex = m_ImageNumberKeyStart + 9;
			SetIndexTabActive();
			return TRUE;
		} else if (nChar >= _T('A') && nChar <= _T('Z')) {
			m_ImageIndex = (nChar - _T('A'))  + m_ImageNumberKeyStart + 10;
			SetIndexTabActive();
			return TRUE;
		// 
		} else if (nChar == VK_RETURN) {
			SetIndexTabActive();
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}
