// DragTreeCtrl.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "DragTreeCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDragTreeCtrl

/// ftHgERXgN^
CDragTreeCtrl::CDragTreeCtrl()
	: m_pDragImage(NULL)	// hbOC[Wi[|C^
	, m_bDrag(FALSE)		// hbOȂTRUEAhbOłȂFALSE
	, m_hitemDrag(0)		// hbOACeiRs[ACej̃nh
	, m_ImageList()
{
}

/// fXgN^
CDragTreeCtrl::~CDragTreeCtrl()
{
	m_ImageList.DeleteImageList();
}


BEGIN_MESSAGE_MAP(CDragTreeCtrl, CTreeCtrl)
	//{{AFX_MSG_MAP(CDragTreeCtrl)
	ON_NOTIFY_REFLECT(TVN_BEGINDRAG, OnBegindrag)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDragTreeCtrl bZ[W nh

/// hbOJn
void CDragTreeCtrl::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// hbOc[ACẽnh擾
	m_hitemDrag = HitTest(pNMTreeView->ptDrag, NULL);
	// hbOC[WiC[WXgj̍쐬
	if ( !(m_pDragImage = CreateDragImage(m_hitemDrag)) )
	{
		return;
	}

	// hbOtOONACImageList::BeginDrag֐s
	m_bDrag = TRUE;
	m_pDragImage->BeginDrag(0, CPoint(0, 0));

	// CImageList::DragEnter֐siW̓XN[WɂKvj
	POINT pt = pNMTreeView->ptDrag;
	ClientToScreen( &pt );
	m_pDragImage->DragEnter(NULL, pt);
	// }EXLv`[
	SetCapture();

	*pResult = 0;
}

/// }EXړ
void CDragTreeCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	if (!(nFlags & MK_LBUTTON))
		m_bDrag = FALSE;
	if (m_bDrag)
	{ // hbO
		HTREEITEM hItem = HitTest(point, NULL);

		// CImageList::DragMove֐siW̓XN[WɂKvj
		POINT pt = point;
		ClientToScreen( &pt );
		CImageList::DragMove(pt);

		// hbv\
		if ( hItem )
		{
			CImageList::DragShowNolock(FALSE);
			SelectDropTarget(hItem);
			CImageList::DragShowNolock(TRUE);
		}
	}
	CTreeCtrl::OnMouseMove(nFlags, point);
}

/// {^
void CDragTreeCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (m_bDrag)
	{
		// hbOtOOFFA}EXLv`[
		m_bDrag = FALSE;
		ReleaseCapture();

		// hbvc[ACẽnh擾
		HTREEITEM hItemDrop = HitTest(point, NULL);

		// CImageList::DragLeave֐CImageList::EndDrag֐s
		CImageList::DragLeave(this);
		CImageList::EndDrag();

		// hbOC[W̔j
		if ( m_pDragImage )
		{
			delete m_pDragImage;
			m_pDragImage = NULL;
		}

		// hbv̋\
		SelectDropTarget(NULL);

		// hbv悪݂Ȃꍇ͉Ȃ
		// hbOACeƃhbvACeꍇ͉Ȃ
		if ( hItemDrop == NULL || m_hitemDrag == hItemDrop )
		{
			return;
		}
		// hbv悪hbOACe̎q̏ꍇ͉Ȃ
		HTREEITEM hItemParent = hItemDrop;
		while( (hItemParent = GetParentItem( hItemParent )) != NULL )
		{
			if ( hItemParent == m_hitemDrag )
			{
				return;
			}
		}

		// ACeRs[ARs[ACe폜
		HTREEITEM itemResult;
		int iImg , iImgSelect;
		GetItemImage(hItemDrop , iImg , iImgSelect);
		if (iImg != 0) { // ACe
			HTREEITEM hInsertAfter = GetNextItem(hItemDrop , TVGN_PREVIOUS);
			if (hInsertAfter == NULL)
				hInsertAfter = TVI_FIRST;

			itemResult = CopyItem(m_hitemDrag, GetParentItem(hItemDrop), hInsertAfter/*TVI_SORT*/);
			DeleteItem(m_hitemDrag);
		}
		else{ // tH_
			itemResult = CopyItem(m_hitemDrag, hItemDrop, TVI_LAST/*TVI_SORT*/);
			DeleteItem(m_hitemDrag);
		}
		SelectItem(itemResult);
	}
	CTreeCtrl::OnLButtonUp(nFlags, point);
}

/// ItemRs[
HTREEITEM CDragTreeCtrl::CopyItem(HTREEITEM hItem, HTREEITEM hParent, HTREEITEM hInsertAfter)
{
	// Rs[ACȅTVITEM\̂Ɏ擾
	TVITEM tvItem;
	tvItem.hItem = hItem;
	tvItem.mask = TVIF_CHILDREN | TVIF_STATE | TVIF_PARAM |
		TVIF_HANDLE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
	GetItem(&tvItem);

	// Rs[ACẽeLXgTVITEM\̂Ɏ擾
	CString strText = GetItemText(hItem);
	tvItem.cchTextMax = strText.GetLength();
	tvItem.pszText = (LPTSTR)(LPCTSTR)strText;

	// ACe}̃}XNݒ
	tvItem.mask = TVIF_STATE | TVIF_PARAM | TVIF_TEXT |
		TVIF_HANDLE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;

	// TVINSERTSTRUCT\̂pӂAlݒ
	TVINSERTSTRUCT tvInsert;
	tvInsert.hParent = hParent;
	tvInsert.hInsertAfter = hInsertAfter;
	tvInsert.item = tvItem;

	// Rs[̐eACeɐVACe}
	HTREEITEM hRetItem = InsertItem(&tvInsert);

	// Rs[ACeqꍇɂ͂Rs[Kv
	HTREEITEM hChild = GetChildItem(hItem);
	while( hChild )
	{
		CopyItem(hChild, hRetItem, TVI_LAST);
		hChild = GetNextSiblingItem(hChild);
	}

	return hRetItem;
}

/// C[W̃[h
BOOL CDragTreeCtrl::LoadBmp(UINT nID)
{
	m_ImageList.Create( 16, 16, ILC_MASK | ILC_COLOR16 , 0	, 2);
	CBitmap bitmap;
	bitmap.LoadBitmap( IDB_EXTPAGE_TREE );
	m_ImageList.Add( &bitmap , RGB(255 , 0 , 255) );
	SetImageList(&m_ImageList , TVSIL_NORMAL);
	return TRUE;
}
