// PageCustommenu.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageCustommenu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "../IDMap.h"
/////////////////////////////////////////////////////////////////////////////
// CPageCustommenu vpeB y[W

IMPLEMENT_DYNCREATE(CPageCustommenu, CPropertyPage)

/// ftHgERXgN^
CPageCustommenu::CPageCustommenu()
	: CPropertyPage(CPageCustommenu::IDD)
	, arrContextID()
	, arrTabbarID()
	, m_IDMap()
	, m_List2()
	, m_List1()
{
	//{{AFX_DATA_INIT(CPageCustommenu)
	m_ContextCustom = FALSE;
	m_TabbarCustom	= FALSE;
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageCustommenu::~CPageCustommenu()
{
}

///
void CPageCustommenu::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageCustommenu)
	DDX_Control(pDX, IDC_LIST2, m_List2);
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Check(pDX, IDC_CHECK1, m_ContextCustom);
	DDX_Check(pDX, IDC_CHECK2, m_TabbarCustom);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageCustommenu, CPropertyPage)
	//{{AFX_MSG_MAP(CPageCustommenu)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageCustommenu bZ[W nh

/// _CAO
BOOL CPageCustommenu::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// JX^j[
	m_ContextCustom = g_Options.UseCustomContext;
	m_TabbarCustom	= g_Options.UseCustomTabmenu;
	UpdateData(FALSE);

	// j[ǂݍ
	LoadIni(0);
	LoadIni(1);

	// LԂ̕ύX
	OnCheck1();
	OnCheck2();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageCustommenu::OnOK()
{
	// JX^j[
	g_Options.UseCustomContext = m_ContextCustom;
	g_Options.UseCustomTabmenu = m_TabbarCustom;
	SaveIni(0);
	SaveIni(1);
	CPropertyPage::OnOK();
}

/// Iniǂݍ
void CPageCustommenu::LoadIni(int mode)
{
	CIDMap		IdMap;
	TCHAR		chrIndex[32];
	CString 	strSession;
	CListBox*	pList;
	if (mode == 0) { // ENbN
		strSession= _T("Context");
		pList = &m_List1;
	} else { // ^uo[
		strSession= _T("Tabbar");
		pList = &m_List2;
	}

	int iCount = GetPrivateProfileInt(strSession, _T("Count"), 0, g_Options.strOptionPath + _T("\\menu.ini") );
	for (int i = 0;i < iCount; i++) {
		_itot(i, chrIndex, 10);
		int iID = GetPrivateProfileInt(strSession, chrIndex, 0, g_Options.strOptionPath+ _T("\\menu.ini") );
		if (iID <= 10) { // ꃁj[
			CString strCaption;
			switch(iID){
			case -1://Zp[^[
				strCaption= _T("----------------");
				break;
			case 1://𑗂
				strCaption= _T("I𕶎𑗂");
				break;
			case 2://URL𑗂
				strCaption= _T("URL𑗂");
				break;
			case 3://ŋߕy[W
				strCaption= _T("ŋߕy[W");
				break;
			case 4://vNV
				strCaption= _T("vNV");
				break;
			}
			pList->AddString(strCaption);
		}
		else {
			pList->AddString(IdMap.Lookup(iID));
		}
		pList->SetItemData(i, iID);
	}
	if (pList->GetCount() > 0) {
		pList->SetCurSel(0);
	}
}

/// Ini
void CPageCustommenu::SaveIni(int mode)
{
	CIDMap		IdMap;
	TCHAR		chrIndex[32];
	CString 	strSession;
	CString 	str;
	CListBox*	pList;
	if (mode == 0) { // ENbN
		strSession= _T("Context");
		pList=&m_List1;
	} else { // ^uo[
		strSession= _T("Tabbar");
		pList=&m_List2;
	}
	if (pList->GetCount() == 0) {
		return;
	}

	_itot(pList->GetCount(), chrIndex, 10);
	WritePrivateProfileString( strSession, _T("Count"), chrIndex, g_Options.strOptionPath + _T("\\menu.ini") );
	for (int i = 0; i < pList->GetCount(); i++) {
		pList->GetText(i, str);
		UINT	id = UINT( pList->GetItemData(i) );

		if (str== _T("----------------") )
			id = -1;
		/*
		else if (str== _T("I𕶎𑗂") )
			id = 1;
		else if (str== _T("URL𑗂") )
			id = 2;
		else if (str== _T("ŋߕy[W") )
			id = 3;
		else if (str== _T("vNV") )
			id = 4;
		else
			id = IdMap.Lookup(str);
		*/

		TCHAR chrID[32];
		_itot(id, chrID,	10);
		_itot( i, chrIndex, 10);
		WritePrivateProfileString( strSession, chrIndex, chrID, g_Options.strOptionPath + _T("\\menu.ini") );
	}
}

/*
void CPageCustommenu::OnSelchangeCombo1()
{ // WύX
	m_Combo2.ResetContent();
	if (m_Combo1.GetCurSel() < m_Combo1.GetCount()-1) {
		// R}h
		CIDMap IDMap;
		int Index = IDMap.GetCategory(m_Combo1.GetCurSel()+1);
		for (int i = Index;i<IDMap.arrStr.GetSize();i++)
			if (IDMap.arrStr.GetAt(i)== _T("") )
				break;
			else
				m_Combo2.AddString(IDMap.arrStr.GetAt(i));
	}
	else{ // 
		m_Combo2.AddString( _T("----------------") );
		m_Combo2.AddString( _T("I𕶎𑗂") );
		m_Combo2.AddString( _T("URL𑗂") );
		m_Combo2.AddString( _T("ŋߕy[W") );
		m_Combo2.AddString( _T("vNV") );
	}
	if (m_Combo2.GetCount()>0)
		m_Combo2.SetCurSel(0);
}
*/

/// ǉ
void CPageCustommenu::OnButton1()
{
	int 	Index = m_List1.GetCurSel();
	// R}h擾
	LRESULT uItem = AfxGetMainWnd()->SendMessage(WM_GETTRACKPOPUP , (WPARAM)GetDlgItem(IDC_BUTTON1)->m_hWnd , 1);		//+++@
	if (uItem == 0) {
		return;
	}
	// \
	CString strCaption;
	if (abs((int)uItem) < 10) {
		switch(uItem){
		case -1://Zp[^[
			strCaption= _T("----------------");
			break;
		case 1://𑗂
			strCaption= _T("I𕶎𑗂");
			break;
		case 2://URL𑗂
			strCaption= _T("URL𑗂");
			break;
		case 3://ŋߕy[W
			strCaption= _T("ŋߕy[W");
			break;
		case 4://vNV
			strCaption= _T("vNV");
			break;
		}
	} else {
		strCaption = m_IDMap.Lookup(UINT(uItem));
	}
	m_List1.InsertString(Index, strCaption);
	m_List1.SetItemData(Index, uItem);
	m_List1.SetCurSel(Index);
}

/// 폜
void CPageCustommenu::OnButton2()
{
	if (m_List1.GetCurSel() < 0) {
		return;
	}
	int Index = m_List1.GetCurSel();
	m_List1.DeleteString(Index);

	if (m_List1.GetCount()>Index) {
		m_List1.SetCurSel(Index);
	} else if (m_List1.GetCount()>0) {
		m_List1.SetCurSel(m_List1.GetCount()-1);
	}
}

/// 
void CPageCustommenu::OnButton3()
{
	if (m_List1.GetCurSel() <= 0) {
		return;
	}
	int Index = m_List1.GetCurSel();

	CString str;
	m_List1.GetText(Index - 1, str);
	DWORD_PTR nID = m_List1.GetItemData(Index - 1); 	//+++@

	m_List1.DeleteString(Index - 1);
	m_List1.InsertString(Index, str);
	m_List1.SetItemData(Index, nID);

	m_List1.SetCurSel(Index - 1);
}

/// 
void CPageCustommenu::OnButton4()
{
	if (m_List1.GetCurSel() == -1 || m_List1.GetCurSel() == m_List1.GetCount()-1) {
		return;
	}
	int Index = m_List1.GetCurSel();

	CString str;
	m_List1.GetText(Index + 1, str);
	DWORD_PTR nID = m_List1.GetItemData(Index + 1); 	//+++@

	m_List1.DeleteString(Index + 1);
	m_List1.InsertString(Index, str);
	m_List1.SetItemData(Index, nID);

	m_List1.SetCurSel(Index + 1);
}

/// ǉ
void CPageCustommenu::OnButton5()
{
	int Index = m_List2.GetCurSel();

	// R}h擾
	LRESULT uItem = AfxGetMainWnd()->SendMessage(WM_GETTRACKPOPUP, (WPARAM)GetDlgItem(IDC_BUTTON5)->m_hWnd, 1); 	//+++@
	if (uItem == 0) {
		return;
	}
	// \
	CString strCaption;
	if (abs((int)uItem) < 10) {
		switch(uItem){
		case -1://Zp[^[
			strCaption= _T("----------------");
			break;
		case 1://𑗂
			strCaption= _T("I𕶎𑗂");
			break;
		case 2://URL𑗂
			strCaption= _T("URL𑗂");
			break;
		case 3://ŋߕy[W
			strCaption= _T("ŋߕy[W");
			break;
		case 4://vNV
			strCaption= _T("vNV");
			break;
		}
	} else {
		strCaption = m_IDMap.Lookup(UINT(uItem));
	}

	m_List2.InsertString(Index, strCaption);
	m_List2.SetItemData(Index, uItem);
	m_List2.SetCurSel(Index);
}

/// 폜
void CPageCustommenu::OnButton6()
{
	if (m_List2.GetCurSel() < 0)
		return;
	int Index = m_List2.GetCurSel();
	m_List2.DeleteString(Index);
	if (m_List2.GetCount()>Index) {
		m_List2.SetCurSel(Index);
	} else if (m_List2.GetCount() > 0) {
		m_List2.SetCurSel(m_List1.GetCount() - 1);
	}
}

/// 
void CPageCustommenu::OnButton7()
{
	if (m_List2.GetCurSel() <= 0)
		return;
	int Index = m_List2.GetCurSel();

	CString str;
	m_List2.GetText(Index - 1, str);
	DWORD_PTR nID = m_List2.GetItemData(Index - 1); 	//+++@

	m_List2.DeleteString(Index - 1);
	m_List2.InsertString(Index, str);
	m_List2.SetItemData(Index, nID);

	m_List2.SetCurSel(Index-1);
}

/// 
void CPageCustommenu::OnButton8()
{
	if (m_List2.GetCurSel() == -1 || m_List2.GetCurSel() == m_List2.GetCount()-1)
		return;
	int Index = m_List2.GetCurSel();

	CString str;
	m_List2.GetText(Index + 1, str);
	DWORD_PTR nID = m_List2.GetItemData(Index + 1); 	//+++@

	m_List2.DeleteString(Index + 1);
	m_List2.InsertString(Index, str);
	m_List2.SetItemData(Index, nID);

	m_List2.SetCurSel(Index+1);
}

/// ENbNj[JX^
void CPageCustommenu::OnCheck1()
{
	CButton* pButton  = static_cast<CButton*>( GetDlgItem(IDC_CHECK1) );
	BOOL	 bChecked = pButton->GetCheck();

	static const UINT s_nWndIDs[6] = { IDC_BUTTON1, IDC_BUTTON2,IDC_BUTTON3, IDC_BUTTON4, IDC_LIST1, 0 };
	for (const UINT* p = s_nWndIDs; *p != 0; p++) {
		GetDlgItem(*p)->EnableWindow(bChecked);
	}
}

/// ^uo[̃j[JX^
void CPageCustommenu::OnCheck2()
{
	CButton* pButton  = static_cast<CButton*>( GetDlgItem(IDC_CHECK2) );
	BOOL	 bChecked = pButton->GetCheck();

	static const UINT s_nWndIDs[6] = { IDC_BUTTON5, IDC_BUTTON6,IDC_BUTTON7, IDC_BUTTON8, IDC_LIST2, 0 };
	for (const UINT* p = s_nWndIDs; *p != 0; p++) {
		GetDlgItem(*p)->EnableWindow(bChecked);
	}
}
