// PageKeyboard.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "..\patriotGlobal2.h"
#include "PageKeyboard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageKeyboard vpeB y[W

IMPLEMENT_DYNCREATE(CPageKeyboard, CPropertyPage)

/// ftHgERXgN^
CPageKeyboard::CPageKeyboard()
	: CPropertyPage(CPageKeyboard::IDD)
	, m_arrID()
	, m_IDMap()
	, m_nSelectedCmd(0)
	, m_List1()
	, m_Key()
{
	//{{AFX_DATA_INIT(CPageKeyboard)
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageKeyboard::~CPageKeyboard()
{
}

///
void CPageKeyboard::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageKeyboard)
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Control(pDX, IDC_EDIT1, m_Key);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageKeyboard, CPropertyPage)
	//{{AFX_MSG_MAP(CPageKeyboard)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnItemchangedList1)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageKeyboard bZ[W nh

/// _CAO
BOOL CPageKeyboard::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_List1.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_List1.InsertColumn(0, _T("")  , NULL , 28);
	m_List1.InsertColumn(1, _T("R}h")	, NULL , 170);

	for (int i = 0;i<255;i++) {
		m_arrID.Add(GetPrivateProfileInt( _T("Keyboard"), _T("Key")+ItoStr(i), 0, g_Options.strOptionPath + _T("\\keyboard.ini") ));
	}
 /*
	// ݒ[h
	CStringList StrList;
	::LoadFileToStrList(g_Options.strAppPath+ _T("\\option\\keyboard.ini") , &StrList);
	// Xgɒǉ
	int i = 0;
	m_arrID.SetSize(256);
	for (i = 0;i<256;i++)
		m_arrID.SetAt(i , 0);

	for (i = 48;i<58;i++)
		m_arrID.SetAt(i, GetProfileIntFromStrList(_T("Keyboard"), _T("Key"+ItoStr(i)) , 0, &StrList) );
	for (i = 65;i<91;i++)
		m_arrID.SetAt(i, GetProfileIntFromStrList(_T("Keyboard"), _T("Key"+ItoStr(i)) , 0, &StrList) );
	for (i = 186;i<226;i++)
		m_arrID.SetAt(i, GetProfileIntFromStrList(_T("Keyboard"), _T("Key"+ItoStr(i)) , 0, &StrList) );
 */
	for (i = 0;i<26;i++) // At@xbg
		AddKey(i+65);
	for (i = 0;i<10;i++) // 
		AddKey(i+48);

	AddKey(189);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("-") );
	AddKey(222);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("^") );
	AddKey(220);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("\\") );
	AddKey(192);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("@") );
	AddKey(219);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("[") );
	AddKey(187);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T(";") );
	AddKey(186);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T(":") );
	AddKey(221);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("]") );
	AddKey(188);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T(",") );
	AddKey(190);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T(".") );
	AddKey(191);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("/") );
	AddKey(226);m_List1.SetItemText(m_List1.GetItemCount()-1 , 0, _T("_") );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageKeyboard::OnOK()
{
  #if 1
	// L[{[h
	CString strText= _T("[Keyboard]\n");
	for (int i = 0;i<255;i++) {
		if (m_arrID.GetAt(i)!=0) // ύXΏ
			strText += ( _T("Key") + ItoStr(i) + _T("=") + ItoStr(m_arrID.GetAt(i)) +_T("\n") );
	}

	//+++ CStdioFile fin( g_Options.strOptionPath + _T("\\keyboard.ini"), CFile::modeCreate | CFile::modeWrite );
	CWriteTextFile fin( g_Options.strOptionPath + _T("\\keyboard.ini"), CFile::modeCreate | CFile::modeWrite );
	fin.WriteString(strText);
	fin.Close();
  #else
	/*
	for (int i = 0;i<255;i++) {
		// ύXȂiniƏƉ
		if (m_arrID.GetAt(i)!= GetPrivateProfileInt( _T("Keyboard") , _T("Key") + ItoStr(i) , 0 , g_Options.strAppPath +	_T("\\option\\keyboard.ini") ) ) {
			// ύXΏ
			WritePrivateProfileString( _T("Keyboard") , _T("Key") + ItoStr(i)) , ItoStr(m_arrID.GetAt(i)) , g_Options.strAppPath +	_T("\\option\\keyboard.ini") );
		}
	}
	*/
  #endif
	CPropertyPage::OnOK();
}

/// L[ǉ
void CPageKeyboard::AddKey(int Ascii)
{
	CString str = (TCHAR)Ascii;
	m_List1.InsertItem(m_List1.GetItemCount() , str , 0);
	m_List1.SetItemText(m_List1.GetItemCount()-1 , 1 , m_IDMap.Lookup(m_arrID.GetAt(Ascii)));
	m_List1.SetItemData(m_List1.GetItemCount()-1 , Ascii);
}

/// XgI
void CPageKeyboard::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// I
	POSITION pos   = m_List1.GetFirstSelectedItemPosition();
	int 	 index = m_List1.GetNextSelectedItem(pos);
	if (index == -1) {
		return;
	}
	// L[\
	CString str = m_List1.GetItemText(index , 0);
	m_Key.SetWindowText(str);
	// R}h\
	str = m_List1.GetItemText(index , 1);
	GetDlgItem(IDC_EDIT2)->SetWindowText(str);
	*pResult = 0;
}

/// ݒ
void CPageKeyboard::OnButton1()
{
	// I擾
	POSITION pos   = m_List1.GetFirstSelectedItemPosition();
	int 	 index = m_List1.GetNextSelectedItem(pos);
	if (index == -1)
		return;

	CString  str;
	GetDlgItem(IDC_EDIT2)->GetWindowText(str);
	m_arrID.SetAt(m_List1.GetItemData(index), m_nSelectedCmd);
	//m_arrID.SetAt(m_List1.GetItemData(index), m_IDMap.Lookup(str));
	m_List1.SetItemText(index, 1, str);
}

/// NA
void CPageKeyboard::OnButton2()
{
	// I擾
	POSITION pos   = m_List1.GetFirstSelectedItemPosition();
	int 	 index = m_List1.GetNextSelectedItem(pos);
	if (index == -1)
		return;

	m_arrID.SetAt(m_List1.GetItemData(index) , 0);
	m_List1.SetItemText(index , 1, _T("") );
}

///
void CPageKeyboard::OnButton3()
{
	LRESULT uItem = AfxGetMainWnd()->SendMessage(WM_GETTRACKPOPUP , (WPARAM)GetDlgItem(IDC_BUTTON3)->m_hWnd , 0);		//+++@
	if (uItem != 0) {// \
		GetDlgItem(IDC_EDIT2)->SetWindowText(m_IDMap.Lookup(UINT(uItem)));
		m_nSelectedCmd = WORD(uItem);
	}
}

