// PageSearch.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageSearch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageSearch vpeB y[W

IMPLEMENT_DYNCREATE(CPageSearch, CPropertyPage)

/// ftHgERXgN^
CPageSearch::CPageSearch() : CPropertyPage(CPageSearch::IDD)
{
	//{{AFX_DATA_INIT(CPageSearch)
	m_GoItemChanged = FALSE;
	m_UseSendstr	= FALSE;
	m_HistoryCount	= 0;
	m_Ctrl1 		= _T("");
	m_Ctrl2 		= _T("");
	m_Ctrl3 		= _T("");
	//}}AFX_DATA_INIT
}

/// fXgN^
CPageSearch::~CPageSearch()
{
}

///
void CPageSearch::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageSearch)
	DDX_Check(pDX, IDC_CHECK2, m_GoItemChanged);
	DDX_Check(pDX, IDC_CHECK1, m_UseSendstr);
	DDX_Text(pDX, IDC_EDIT3, m_HistoryCount);
	DDV_MinMaxUInt(pDX, m_HistoryCount, 0, 255);
	DDX_CBString(pDX, IDC_COMBO1, m_Ctrl1);
	DDX_CBString(pDX, IDC_COMBO2, m_Ctrl2);
	DDX_CBString(pDX, IDC_COMBO3, m_Ctrl3);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageSearch, CPropertyPage)
	//{{AFX_MSG_MAP(CPageSearch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPageSearch bZ[W nh

/// _CAO
BOOL CPageSearch::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// sendstr.ini烊Xgǂݍ
	CComboBox* pCombo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);
	CComboBox* pCombo2 = (CComboBox*)GetDlgItem(IDC_COMBO2);
	CComboBox* pCombo3 = (CComboBox*)GetDlgItem(IDC_COMBO3);

	TCHAR chrBuf[1024*32];
	::GetPrivateProfileSectionNames(chrBuf, 1024*32, g_Options.strOptionPath + _T("\\sendstr.ini") );

	pCombo1->AddString( _T("") );
	pCombo2->AddString( _T("") );
	pCombo3->AddString( _T("") );
	LPTSTR pChr = chrBuf;
	while (*pChr != _T('\0')){
		pCombo1->AddString(pChr);
		pCombo2->AddString(pChr);
		pCombo3->AddString(pChr);
		pChr += lstrlen(pChr) + 1;
	}
	m_UseSendstr	= g_Options.SearchUseSendstr;
	m_GoItemChanged = g_Options.SearchGoItemChanged;
	m_HistoryCount	= g_Options.SearchHistoryCount;
	m_Ctrl1 = g_Options.strSearchCtrl1;
	m_Ctrl2 = g_Options.strSearchCtrl2;
	m_Ctrl3 = g_Options.strSearchCtrl3;

	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ݒۑ
void CPageSearch::OnOK()
{
	g_Options.SearchUseSendstr		= m_UseSendstr;
	g_Options.SearchGoItemChanged	= m_GoItemChanged;
	g_Options.SearchHistoryCount	= m_HistoryCount;
	g_Options.strSearchCtrl1		= m_Ctrl1;
	g_Options.strSearchCtrl2		= m_Ctrl2;
	g_Options.strSearchCtrl3		= m_Ctrl3;

	CPropertyPage::OnOK();
}