#if !defined(COMMON_CLASS_GESTUREMANAGER)
#define COMMON_CLASS_GESTUREMANAGER

#include "StdAfx.h"

class CGestureManager{
public:
	CStringArray	m_arrMouseAction;
	CUIntArray		m_arrMouseCommand;
	CString 		m_strSettingFile;
protected:
	BOOL			m_DrawLine;
	int 			m_MinPixel;
	COLORREF		m_LineColor;

public:
	CGestureManager();
	CGestureManager(CString strPath);
	~CGestureManager();

	virtual void SaveSetting();
	virtual void LoadSetting();

	virtual BOOL TranslateGesture(MSG* pMsg);

protected:
	virtual void DrawLine(CPoint ptFrom , CPoint ptTo);
	virtual void ShowMouseCommand(CString strMouseCommand);
	virtual BOOL DoMouseCommand(CString strMouseCommand);

	/*
	CString ItoStr(int value);
	void WriteProfileInt(LPCTSTR strKey , int iValue , LPCTSTR strFile);
	int GetProfileInt(LPCTSTR strKey , LPCTSTR strFile);
	*/
};

#endif
