#if !defined(AFX_OPTIONDLGEX_H__4357C5D2_765A_4F16_8DA2_8E13DA1142DC__INCLUDED_)
#define AFX_OPTIONDLGEX_H__4357C5D2_765A_4F16_8DA2_8E13DA1142DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionDlgEx.h : wb_[ t@C
//
#include "resource.h"
#include "../resource.h"

#include "PageNomal.h"
#include "PageTab.h"
#include "PageNew.h"
#include "PageSecurity.h"
#include "PageFavorites.h"
#include "PageToolbar.h"
#include "PageAddress.h"
#include "PageSearch.h"
#include "PageProxy.h"
#include "PageFilter.h"
#include "PageKeyboard.h"
#include "PageMouse.h"
#include "PageMouse2.h"
#include "PageAlert.h"
#include "PageEditmenu.h"
#include "PageCustommenu.h"
#include "PagePopup.h"
#include "PageDownload.h"
#include "PageAccel.h"
#include "PageStartUp.h"
#include "PageClosedUrl.h"
#include "PageSidebar.h"
#include "PageLinkbar.h"
#include "PageExit.h"
#include "PageThumbnail.h"
/////////////////////////////////////////////////////////////////////////////
// COptionDlgEx _CAO

#define PAGE_COUNT	40

class COptionDlgEx : public CDialog
{
// RXgNV
public:
	COptionDlgEx(CWnd* pParent = NULL);   // W̃RXgN^
private:
	CWnd*			m_pCurPageWnd;

	CPageNomal		m_pageNomal;
	CPageTab		m_pageTab;
	CPageNew		m_pageNew;
	CPageSecurity	m_pageSecurity;
	CPageFavorites	m_pageFavorites;
	CPageToolbar	m_pageToolbar;
	CPageAddress	m_pageAddress;
	CPageSearch 	m_pageSearch;
	CPageProxy		m_pageProxy;
	CPageFilter 	m_pageFilter;
	CPageKeyboard	m_pageKeyboard;
	CPageMouse		m_pageMouse;
	CPageMouse2 	m_pageMouse2;
	CPageAlert		m_pageAlert;
	CPagePopup		m_pagePopup;
	CPageEditmenu	m_pageEditMenu;
	CPageCustommenu m_pageCustomMenu;
	CPageDownload	m_pageDownload;
	CPageAccel		m_pageAccel;
	CPageStartup	m_pageStartup;
	CPageClosedUrl	m_pageClosedUrl;
	CPageSidebar	m_pageSidebar;
	CPageLinkbar	m_pageLinkbar;
	CPageExit		m_pageExit;
	CPageThumbnail	m_pageThumbnail;

	CString 		m_strPage[PAGE_COUNT];
	CWnd*			m_wndPage[PAGE_COUNT];
	UINT			m_nPageID[PAGE_COUNT];

public:
	HTREEITEM AddPage(HTREEITEM itemParent, CWnd* pWnd, LPCTSTR strPageName, UINT nID);
	BOOL SetActivePage(CString strItem);
// _CAO f[^
	//{{AFX_DATA(COptionDlgEx)
	enum { IDD = IDD_OPTIONDLGEX };
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(COptionDlgEx)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(COptionDlgEx)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnOK();
	afx_msg void OnDestroy();
	//}}AFX_MSG
//	afx_msg LRESULT OnTrackPopupMenu(WPARAM wParam = 0, LPARAM lParam = 0);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_OPTIONDLGEX_H__4357C5D2_765A_4F16_8DA2_8E13DA1142DC__INCLUDED_)
